searchNodes=[{"doc":"The Partisan API. Some of the functions in this module are the Partisan counterparts of a subset of the functions found in the erlang and net_kernel modules. -----------------------------------------------------------------------------","ref":"partisan.html","title":"partisan","type":"module"},{"doc":"Broadcasts a message originating from this node. The message will be delivered to each node at least once. The Mod passed is responsible for handling the message on remote nodes as well as providing some other information both locally and and on other nodes. Mod must be loaded on all members of the clusters and implement the partisan_plumtree_broadcast_handler behaviour.","ref":"partisan.html#broadcast/2","title":"partisan.broadcast/2","type":"function"},{"doc":"","ref":"partisan.html#cancel_timer/1","title":"partisan.cancel_timer/1","type":"function"},{"doc":"","ref":"partisan.html#cancel_timer/2","title":"partisan.cancel_timer/2","type":"function"},{"doc":"Cast message to a remote ref","ref":"partisan.html#cast_message/2","title":"partisan.cast_message/2","type":"function"},{"doc":"Cast message to registered process on the remote side.","ref":"partisan.html#cast_message/3","title":"partisan.cast_message/3","type":"function"},{"doc":"Cast message to registered process on the remote side.","ref":"partisan.html#cast_message/4","title":"partisan.cast_message/4","type":"function"},{"doc":"Returns a channel with name Name . Fails if a channel named Name doesn't exist.","ref":"partisan.html#channel_opts/1","title":"partisan.channel_opts/1","type":"function"},{"doc":"","ref":"partisan.html#default_channel/0","title":"partisan.default_channel/0","type":"function"},{"doc":"It differs from erlang:demonitor/1 in that it doesn't fail if MonitorRef refers to a monitoring started by another process.","ref":"partisan.html#demonitor/1","title":"partisan.demonitor/1","type":"function"},{"doc":"","ref":"partisan.html#demonitor/2","title":"partisan.demonitor/2","type":"function"},{"doc":"","ref":"partisan.html#disconnect_node/1","title":"partisan.disconnect_node/1","type":"function"},{"doc":"","ref":"partisan.html#exit/2","title":"partisan.exit/2","type":"function"},{"doc":"Forward message to registered process on the remote side.","ref":"partisan.html#forward_message/2","title":"partisan.forward_message/2","type":"function"},{"doc":"Forward message to registered process on the remote side.","ref":"partisan.html#forward_message/3","title":"partisan.forward_message/3","type":"function"},{"doc":"Forward message to registered process on the remote side.","ref":"partisan.html#forward_message/4","title":"partisan.forward_message/4","type":"function"},{"doc":"Returns true if the local node is alive (that is, if the node can be part of a distributed system), otherwise false.","ref":"partisan.html#is_alive/0","title":"partisan.is_alive/0","type":"function"},{"doc":"Returns the name of the local node.","ref":"partisan.html#is_connected/1","title":"partisan.is_connected/1","type":"function"},{"doc":"Returns the name of the local node.","ref":"partisan.html#is_connected/2","title":"partisan.is_connected/2","type":"function"},{"doc":"Returns the name of the local node.","ref":"partisan.html#is_fully_connected/1","title":"partisan.is_fully_connected/1","type":"function"},{"doc":"Returns the name of the local node.","ref":"partisan.html#is_local/1","title":"partisan.is_local/1","type":"function"},{"doc":"","ref":"partisan.html#is_local_name/1","title":"partisan.is_local_name/1","type":"function"},{"doc":"","ref":"partisan.html#is_local_name/2","title":"partisan.is_local_name/2","type":"function"},{"doc":"","ref":"partisan.html#is_local_pid/1","title":"partisan.is_local_pid/1","type":"function"},{"doc":"","ref":"partisan.html#is_local_pid/2","title":"partisan.is_local_pid/2","type":"function"},{"doc":"","ref":"partisan.html#is_local_reference/1","title":"partisan.is_local_reference/1","type":"function"},{"doc":"","ref":"partisan.html#is_local_reference/2","title":"partisan.is_local_reference/2","type":"function"},{"doc":"","ref":"partisan.html#is_pid/1","title":"partisan.is_pid/1","type":"function"},{"doc":"Returns the name of the local node.","ref":"partisan.html#is_process_alive/1","title":"partisan.is_process_alive/1","type":"function"},{"doc":"Returns the name of the local node.","ref":"partisan.html#is_reference/1","title":"partisan.is_reference/1","type":"function"},{"doc":"Returns true if Arg is the caller's process identifier.","ref":"partisan.html#is_self/1","title":"partisan.is_self/1","type":"function"},{"doc":"Returns a new partisan_remote_ref. This is the same as calling partisan_remote_ref:from_term(erlang:make_ref()) .","ref":"partisan.html#make_ref/0","title":"partisan.make_ref/0","type":"function"},{"doc":"","ref":"partisan.html#monitor/1","title":"partisan.monitor/1","type":"function"},{"doc":"Sends a monitor request of type Type to the entity identified by Item . If the monitored entity does not exist or it changes monitored state, the caller of monitor/2 is notified by a message on the following format: {Tag, MonitorRef, Type, Object, Info} This is the Partisan's equivalent to erlang:monitor/2 . Failure: notalive if the partisan_monitor server is not alive.","ref":"partisan.html#monitor/2","title":"partisan.monitor/2","type":"function"},{"doc":"Sends a monitor request of type Type to the entity identified by Item . If the monitored entity does not exist or it changes monitored state, the caller of monitor/2 is notified by a message on the following format: {Tag, MonitorRef, Type, Object, Info} where it differs from the message sent by erlang:monitor/3 only when the item being monitored is a remote process identifier erlang:monitor/3 in which case: MonitorRef is a remote_reference() Object is a remote_pid() or remote_name() This is the Partisan's equivalent to erlang:monitor/2 . It differs from the Erlang implementation only when monitoring a process . For all other cases (monitoring a port or time_offset ) this function calls erlang:monitor/2 . As opposed to erlang:monitor/2 this function does not support aliases. Monitoring a `process` Creates monitor between the current process and another process identified by Item, which can be a pid() (local or remote), an atom RegisteredName or a tuple {RegisteredName, Node} ' for a registered process, located elsewhere. In the case of a local pid() or a remote pid() A process monitor by name resolves the RegisteredName to pid() or port() only once at the moment of monitor instantiation, later changes to the name registration will not affect the existing monitor. Failure: if the partisan_monitor server is not alive, a reference will be returned with an immediate 'DOWN' signal with reason notalive .","ref":"partisan.html#monitor/3","title":"partisan.monitor/3","type":"function"},{"doc":"Monitor the status of the node Node . If Flag is true, monitoring is turned on. If Flag is false , monitoring is turned off. Making several calls to monitor_node(Node, true) for the same Node from is not an error; it results in as many independent monitoring instances as the number of different calling processes i.e. If a process has made two calls to monitor_node(Node, true) and Node terminates, only one nodedown message is delivered to the process (this differs from erlang:monitor_node/2 ). If Node fails or does not exist, the message {nodedown, Node} is delivered to the calling process. If there is no connection to Node, a nodedown message is delivered. As a result when using a membership strategy that uses a partial view, you can not monitor nodes that are not members of the view. If Node is the caller's node, the function returns false .","ref":"partisan.html#monitor_node/2","title":"partisan.monitor_node/2","type":"function"},{"doc":"Monitor the status of the node Node . If Flag is true, monitoring is turned on. If Flag is false , monitoring is turned off. Making several calls to monitor_node(Node, true) for the same Node from is not an error; it results in as many independent monitoring instances as the number of different calling processes i.e. If a process has made two calls to monitor_node(Node, true) and Node terminates, only one nodedown message is delivered to the process (this differs from erlang:monitor_node/2 ). If Node fails or does not exist, the message {nodedown, Node} is delivered to the calling process. If there is no connection to Node, a nodedown message is delivered. As a result when using a membership strategy that uses a partial view, you can not monitor nodes that are not members of the view. If Node is the caller's node, the function returns false .","ref":"partisan.html#monitor_node/3","title":"partisan.monitor_node/3","type":"function"},{"doc":"","ref":"partisan.html#monitor_nodes/1","title":"partisan.monitor_nodes/1","type":"function"},{"doc":"The calling process subscribes or unsubscribes to node status change messages. A nodeup message is delivered to all subscribing processes when a new node is connected, and a nodedown message is delivered when a node is disconnected.","ref":"partisan.html#monitor_nodes/2","title":"partisan.monitor_nodes/2","type":"function"},{"doc":"Returns the name of the local node.","ref":"partisan.html#node/0","title":"partisan.node/0","type":"function"},{"doc":"Returns the node where Arg originates. Arg can be a process identifier, a reference, a port or a partisan remote reference.","ref":"partisan.html#node/1","title":"partisan.node/1","type":"function"},{"doc":"Returns the node specification of the local node. This is the information required when other nodes wish to join this node (See partisan_peer_service:join/1 ). Notice that the values of the keys must be sorted for the peer service to be able to compare node specifications, and prevent duplicates in the membership view data structure. This is important in case you find yourself building this representation manually in order to implement a particular orchestration strategy. As Erlang maps are naturally sorted, the only property that you need to keep sorted is listen_addrs as it is implemented as a list.","ref":"partisan.html#node_spec/0","title":"partisan.node_spec/0","type":"function"},{"doc":"Return the partisan node_spec() for node named Node . This function retrieves the node_spec/0 from the remote node using RPC and returns {error, Reason} if the RPC fails. Otherwise, assumes the node is running on the same host and returns a node_spec/0 with with nodename Name and host 'Host' and same metadata as myself/0 . If configuration option connect_disterl is true , the RPC will be implemented using the rpc module. Otherwise it will use partisan_rpc . You should only use this function when distributed erlang is enabled (configuration option connect_disterl is true ) or if the node is running on the same host and you are using this for testing purposes as there is no much sense in running a partisan cluster on a single host.","ref":"partisan.html#node_spec/1","title":"partisan.node_spec/1","type":"function"},{"doc":"Return the tuple {ok, node_spec() for node named Node or the tuple {error, Reason} . This function first checks If there is a partisan connection to Node , if so returns the cached specification that was used for creating the connection. If no connection is present (the case for a p2p topology), then it tries to use @link partisan_rpc} to retrieve the node specification from the remote node. This later alternative requires the partisan configuration forward_opts` to have `broadcast and transitive enabled. NOTICE: At the moment partisan_rpc might not work correctly w/ a p2p topology.","ref":"partisan.html#node_spec/2","title":"partisan.node_spec/2","type":"function"},{"doc":"Returns a list of all nodes connected to this node via Partisan. Equivalent to erlang:nodes/1 . Sames as calling nodes(visible) . Notice that if connect_disterl is true (possibly the case when testing), this function will NOT return the disterl nodes. For that you still need to call erlang:nodes/1 .","ref":"partisan.html#nodes/0","title":"partisan.nodes/0","type":"function"},{"doc":"Returns a list of nodes according to the argument specified. The returned result, when the argument is a list, is the list of nodes satisfying the disjunction(s) of the list elements. Differences with Erlang: hidden - always returns the empty list (there is no concept of hidden nodes in Partisan). this - returns the list containing the result of calling node/0 known - will return the nodes known by the partisan_peer_service i.e. partisan_peer_service:members/0 but not the nodes referred to by process identifiers, port identifiers, and references located on this node. visible - equivalent to Erlang.","ref":"partisan.html#nodes/1","title":"partisan.nodes/1","type":"function"},{"doc":"Returns the name of the local node as a binary string.","ref":"partisan.html#nodestring/0","title":"partisan.nodestring/0","type":"function"},{"doc":"","ref":"partisan.html#process_info/1","title":"partisan.process_info/1","type":"function"},{"doc":"","ref":"partisan.html#process_info/2","title":"partisan.process_info/2","type":"function"},{"doc":"Returns the partisan encoded pid for the calling process. This is equivalent to calling partisan_remote_ref:from_term(self()) . Notice that this call is more expensive than It's erlang counterpart. So you might want to cache the result in your process state. See function self/1 which allows you to cache the result in the process dictionary and take notice of the warning related to doing this on an Erlang Shell process.","ref":"partisan.html#self/0","title":"partisan.self/0","type":"function"},{"doc":"Returns the partisan encoded pid for the calling process. If Opts is the empty list, this is equivalent to calling partisan_remote_ref:from_term(self()) . Otherwise, if the option cache is present in Opts the function lazily caches the result of calling partisan_remote_ref:from_term/1 in the process dictionary the first time and retrieves the value in subsequent calls. NOTICE You SHOULD avoid using this function in the Erlang Shell. This is because when an Erlang Shell process crashes it will copy the contents of It's dictionary to the new shell process and thus you will end up with the wrong partisan remote reference.","ref":"partisan.html#self/1","title":"partisan.self/1","type":"function"},{"doc":"","ref":"partisan.html#send/2","title":"partisan.send/2","type":"function"},{"doc":"","ref":"partisan.html#send/3","title":"partisan.send/3","type":"function"},{"doc":"Equivalent to calling send_after(Time, Dest, Msg, []) .","ref":"partisan.html#send_after/3","title":"partisan.send_after/3","type":"function"},{"doc":"Equivalent to the native erlang:send_after/4 . It calls the native implementation for local destinations. For remote destinations it spawns a process that uses a timer and accepts cancellation ( via cancel_timer/1,2 ), so this is less efficient than the native implementation.","ref":"partisan.html#send_after/4","title":"partisan.send_after/4","type":"function"},{"doc":"","ref":"partisan.html#spawn/2","title":"partisan.spawn/2","type":"function"},{"doc":"","ref":"partisan.html#spawn/4","title":"partisan.spawn/4","type":"function"},{"doc":"","ref":"partisan.html#spawn_monitor/2","title":"partisan.spawn_monitor/2","type":"function"},{"doc":"","ref":"partisan.html#spawn_monitor/4","title":"partisan.spawn_monitor/4","type":"function"},{"doc":"Start the application.","ref":"partisan.html#start/0","title":"partisan.start/0","type":"function"},{"doc":"Stop the application.","ref":"partisan.html#stop/0","title":"partisan.stop/0","type":"function"},{"doc":"Fails with badarg if Arg is a remote reference for another node.","ref":"partisan.html#whereis/1","title":"partisan.whereis/1","type":"function"},{"doc":"","ref":"partisan.html#t:actor/0","title":"partisan.actor/0","type":"type"},{"doc":"","ref":"partisan.html#t:any_name/0","title":"partisan.any_name/0","type":"type"},{"doc":"","ref":"partisan.html#t:any_pid/0","title":"partisan.any_pid/0","type":"type"},{"doc":"","ref":"partisan.html#t:any_reference/0","title":"partisan.any_reference/0","type":"type"},{"doc":"","ref":"partisan.html#t:channel/0","title":"partisan.channel/0","type":"type"},{"doc":"","ref":"partisan.html#t:channel_opt/0","title":"partisan.channel_opt/0","type":"type"},{"doc":"","ref":"partisan.html#t:channel_opts/0","title":"partisan.channel_opts/0","type":"type"},{"doc":"","ref":"partisan.html#t:demonitor_opt/0","title":"partisan.demonitor_opt/0","type":"type"},{"doc":"","ref":"partisan.html#t:forward_opts/0","title":"partisan.forward_opts/0","type":"type"},{"doc":"","ref":"partisan.html#t:listen_addr/0","title":"partisan.listen_addr/0","type":"type"},{"doc":"","ref":"partisan.html#t:message/0","title":"partisan.message/0","type":"type"},{"doc":"","ref":"partisan.html#t:monitor_nodes_opt/0","title":"partisan.monitor_nodes_opt/0","type":"type"},{"doc":"","ref":"partisan.html#t:monitor_opt/0","title":"partisan.monitor_opt/0","type":"type"},{"doc":"","ref":"partisan.html#t:net_kernel_opt/0","title":"partisan.net_kernel_opt/0","type":"type"},{"doc":"","ref":"partisan.html#t:node_spec/0","title":"partisan.node_spec/0","type":"type"},{"doc":"","ref":"partisan.html#t:node_type/0","title":"partisan.node_type/0","type":"type"},{"doc":"","ref":"partisan.html#t:remote_name/0","title":"partisan.remote_name/0","type":"type"},{"doc":"","ref":"partisan.html#t:remote_pid/0","title":"partisan.remote_pid/0","type":"type"},{"doc":"","ref":"partisan.html#t:remote_reference/0","title":"partisan.remote_reference/0","type":"type"},{"doc":"","ref":"partisan.html#t:send_after_dst/0","title":"partisan.send_after_dst/0","type":"type"},{"doc":"","ref":"partisan.html#t:send_after_opts/0","title":"partisan.send_after_opts/0","type":"type"},{"doc":"","ref":"partisan.html#t:send_dst/0","title":"partisan.send_dst/0","type":"type"},{"doc":"","ref":"partisan.html#t:server_ref/0","title":"partisan.server_ref/0","type":"type"},{"doc":"","ref":"partisan.html#t:time/0","title":"partisan.time/0","type":"type"},{"doc":"This module handles the validation, access and modification of Partisan configuration options. Some options will only take effect after a restart of the Partisan application, while other will take effect while the application is still running. As per Erlang convention the options are given using the sys.config file under the partisan application section. Options The following is the list of all the options you can read using get/ 1 and get/2 , and modify using the sys.config file and set/ 2 . See Deprecated Options below. binary_padding A boolean value indicating whether to pad encoded messages whose external binary representation consumes less than 65 bytes. broadcast TBD broadcast_mods TBD causal_labels TBD channels Defines the channels to be used by Partisan. The option takes either a channels map where keys are channel names ( partisan:channel() ) and values are channel options ( partisan:channel_opts() ), or a list of values where each value can be any of the following types: a channel name ( partisan:channel() ) e.g. the atom foo a channel with options: {channel(), channel_opts()} a monotonic channel using the tuple {monotonic, Name :: channel()} e.g. {monotonic, bar} . This is a legacy representation, the same can be achieved with {bar, \#{monotonic =&gt; true}} The list can habe a mix of types and during startup they are all coerced to channels map. Coercion works by defaulting the channel's parallelism to the value of the global option parallelism (which itself defaults to 1 ), and the channel's monotonic to false . Finally the list is transformed to a map where keys are channel names and values are channel map representation. Example: Given the following option value: [ foo , { monotonic , bar } , { bar , \#{ parallelism =&gt; 4 } } ] The coerced representation will be the following map (which is a valid input and the final representation of this option after Partisan starts). \#{ foo =&gt; \#{ monotonic =&gt; false , parallelism =&gt; 1 } , bar =&gt; \#{ monotonic =&gt; true , parallelism =&gt; 1 } , baz =&gt; \#{ monotonic =&gt; false , parallelism =&gt; 4 } , } connect_disterl Whether to use distributed erlang in addition to Partisan channels. This is used for testing and only works for partisan_full_membership_strategy (See membership_strategy ). Defaults to false connection_interval Interval of time between peer connection attempts connection_jitter TBD disable_fast_forward TBD disable_fast_receive TBD distance_enabled TBD egress_delay TBD exchange_selection TBD exchange_tick_period TBD gossip If true gossip is used to disseminate membership state. hyparview The configuration for the partisan_hyparview_peer_service_manager . A list with the following properties: active_max_size Defaults to 6 . active_min_size Defaults to 3 . active_rwl Active View Random Walk Length. Defaults to 6 . passive_max_size Defaults to 30 . passive_rwl Passive View Random Walk Length. Defaults to 6 . random_promotion A boolean indicating if random promotion is enabled. Defaults true . random_promotion_interval Time after which the protocol attempts to promote a node in the passive view to the active view. Defaults to 5000 . shuffle_interval Defaults to 10000 . shuffle_k_active Number of peers to include in the shuffle exchange. Defaults to 3 . shuffle_k_passive Number of peers to include in the shuffle exchange. Defaults to 4 . ingress_delay TBD lazy_tick_period TBD membership_binary_compression A boolean value or an integer in the range from 0..9 to be used with erlang:term_to_binary/2 when encoding the membership set for broadcast. A value of true is equivalent to integer 6 (equivalent to option compressed in erlang:term_to_binary/2 ). A value of false is equivalent to 0 (no compression). Default is true . membership_strategy The membership strategy to be used with partisan_pluggable_peer_service_manager . Default is partisan_full_membership_strategy membership_strategy_tracing TBD name TBD orchestration_strategy TBD parallelism TBD peer_service_manager The peer service manager to be used. An implementation of the partisan_peer_service_manager behaviour which defines the overlay network topology and the membership view maintenance strategy. Default is partisan_pluggable_peer_service_manager . peer_host TBD peer_ip TBD peer_port TBD periodic_enabled TBD periodic_interval TBD pid_encoding TBD random_seed TBD ref_encoding TBD register_pid_for_encoding TBD remote_ref_format If uri partisan remote references (see module partisan_remote_ref ) will be encoded as a URI binary, if tuple it will be encoded as a tuple (the format used by Partisan v1 to v4). Otherwise, if improper_list it will be encoded as an improper list, similar to how aliases are encoded by the OTP modules. This option exists to allow the user to tradeoff between memory and latency. In terms of memory uri is the cheapest, followed by improper_list . In terms of latency tuple is the fastest followed by improper_list . The default is improper_list a if offers a good balance between memory and latency. 1 &gt; partisan_config : set ( remote_ref_format , uri ) . ok 2 &gt; partisan_remote_ref : from_term ( self ( ) ) . &lt;&lt; &quot;partisan:pid:nonode@nohost:0.1062.0&quot; &gt;&gt; 3 &gt; partisan_config : set ( remote_ref_format , tuple ) . 4 &gt; partisan_remote_ref : from_term ( self ( ) ) . { partisan_remote_reference , nonode @ nohost , { partisan_process_reference , &quot;&lt;0.1062.0&gt;&quot; } } 5 &gt; partisan_config : set ( remote_ref_format , improper_list ) . 6 &gt; partisan_remote_ref : from_term ( self ( ) ) . [ nonode @ nohost | &lt;&lt; &quot;Pid#&lt;0.1062.0&gt;&quot; &gt;&gt; ] remote_ref_uri_padding If true and the URI encoding of a remote reference results in a binary smaller than 65 bytes, the URI will be padded. The default is false . %% 1 &gt; partisan_config : set ( remote_ref_binary_padding , false ) . 1 &gt; partisan_remote_ref : from_term ( self ( ) ) . &lt;&lt; &quot;partisan:pid:nonode@nohost:0.1062.0&quot; &gt;&gt; 2 &gt; partisan_config : set ( remote_ref_binary_padding , true ) . ok 3 &gt; partisan_remote_ref : from_term ( self ( ) ) . &lt;&lt; &quot;partisan:pid:nonode@nohost:0.1062.0:&quot; . . . &gt;&gt; replaying TBD reservations TBD retransmit_interval Interval of time between retransmission attempts shrinking TBD tag The role of this node when using partisan_client_server_peer_manager . Values can be client or server . Use undefined when using a different peer service manager. tls a boolean value indicating whether channel connections should use TLS. If enabled, you have to provide a value for tls_client_options and tls_server_options . The default is false . tls_client_options The default is [] . tls_server_options The default is [] . tracing a boolean value. The default is false . xbot_interval TBD Deprecated Options The following is the list of options have been deprecated. Some of them have been renamed and/or moved down a level in the configuration tree. arwl HyParView's Active View Random Walk Length. Defaults to 6 . Use active_rwl in the hyparview option instead. fanout The number of nodes that are contacted at each gossip interval. max_active_size HyParView's Active View Random Walk Length. Defaults to 6 . Use active_max_size in the hyparview option instead. max_passive_size HyParView's Active View Random Walk Length. Defaults to 30 . Use passive_max_size in the hyparview option instead. mix_active_size HyParView's Active View Random Walk Length. Defaults to 3 . Use active_min_size in the hyparview option instead. passive_view_shuffle_period Use shuffle_interval in the hyparview option instead. partisan_peer_service_manager Use peer_service_manager instead. prwl HyParView's Passive View Random Walk Length. Defaults to 6 . Use passive_rwl in the hyparview option instead. random_promotion Use random_promotion in the hyparview option instead. random_promotion_period Use random_promotion_interval in the hyparview option instead. remote_ref_as_uri Use {remote_ref_format, uri} instead","ref":"partisan_config.html","title":"partisan_config","type":"module"},{"doc":"","ref":"partisan_config.html#channel_opts/1","title":"partisan_config.channel_opts/1","type":"function"},{"doc":"","ref":"partisan_config.html#channels/0","title":"partisan_config.channels/0","type":"function"},{"doc":"The name of the default channel.","ref":"partisan_config.html#default_channel/0","title":"partisan_config.default_channel/0","type":"function"},{"doc":"The spec of the default channel.","ref":"partisan_config.html#default_channel_opts/0","title":"partisan_config.default_channel_opts/0","type":"function"},{"doc":"","ref":"partisan_config.html#get/1","title":"partisan_config.get/1","type":"function"},{"doc":"","ref":"partisan_config.html#get/2","title":"partisan_config.get/2","type":"function"},{"doc":"Returns the value for Key in Opts , if found. Otherwise, calls get/1 .","ref":"partisan_config.html#get_with_opts/2","title":"partisan_config.get_with_opts/2","type":"function"},{"doc":"Returns the value for Key in Opts , if found. Otherwise, calls get/2 .","ref":"partisan_config.html#get_with_opts/3","title":"partisan_config.get_with_opts/3","type":"function"},{"doc":"Initialises the configuration from the application environment. You should never call this function . This is used by Partisan itself during startup. The function is (and should be) idempotent, which is required for testing.","ref":"partisan_config.html#init/0","title":"partisan_config.init/0","type":"function"},{"doc":"","ref":"partisan_config.html#listen_addrs/0","title":"partisan_config.listen_addrs/0","type":"function"},{"doc":"","ref":"partisan_config.html#parallelism/0","title":"partisan_config.parallelism/0","type":"function"},{"doc":"","ref":"partisan_config.html#random_seed/0","title":"partisan_config.random_seed/0","type":"function"},{"doc":"Seed the process.","ref":"partisan_config.html#seed/0","title":"partisan_config.seed/0","type":"function"},{"doc":"Seed the process.","ref":"partisan_config.html#seed/1","title":"partisan_config.seed/1","type":"function"},{"doc":"","ref":"partisan_config.html#set/2","title":"partisan_config.set/2","type":"function"},{"doc":"","ref":"partisan_config.html#trace/2","title":"partisan_config.trace/2","type":"function"},{"doc":"This modules implements the Peer Service API. All functions in this module forward the invocation to the configured peer service manager (option peer_service_manager ) which must be one of the Partisan's managers implementing partisan_peer_service_manager , i.e. one of: partisan_pluggable_peer_service_manager partisan_client_server_peer_service_manager partisan_hyparview_peer_service_manager partisan_static_peer_service_manager Each node running Partisan listens for connections on a particular IP address and port. This is the information that is required when other nodes wish to join this node.","ref":"partisan_peer_service.html","title":"partisan_peer_service","type":"module"},{"doc":"Adds a supervised callback to receive peer service membership updates.","ref":"partisan_peer_service.html#add_sup_callback/1","title":"partisan_peer_service.add_sup_callback/1","type":"function"},{"doc":"Returns the broadcast servers view of full cluster membership. Wait indefinitely for a response is returned from the process.","ref":"partisan_peer_service.html#broadcast_members/0","title":"partisan_peer_service.broadcast_members/0","type":"function"},{"doc":"Returns the broadcast servers view of full cluster membership. Waits Timeout ms for a response from the server.","ref":"partisan_peer_service.html#broadcast_members/1","title":"partisan_peer_service.broadcast_members/1","type":"function"},{"doc":"cancel exchanges started by this node.","ref":"partisan_peer_service.html#cancel_exchanges/1","title":"partisan_peer_service.cancel_exchanges/1","type":"function"},{"doc":"Return peer service connections","ref":"partisan_peer_service.html#connections/0","title":"partisan_peer_service.connections/0","type":"function"},{"doc":"Decode peer_service_manager state from an encoded form","ref":"partisan_peer_service.html#decode/1","title":"partisan_peer_service.decode/1","type":"function"},{"doc":"return a list of exchanges, started by broadcast on thisnode, that are running.","ref":"partisan_peer_service.html#exchanges/0","title":"partisan_peer_service.exchanges/0","type":"function"},{"doc":"returns a list of exchanges, started by broadcast on Node , that are running.","ref":"partisan_peer_service.html#exchanges/1","title":"partisan_peer_service.exchanges/1","type":"function"},{"doc":"","ref":"partisan_peer_service.html#get_local_state/0","title":"partisan_peer_service.get_local_state/0","type":"function"},{"doc":"Inject a partition.","ref":"partisan_peer_service.html#inject_partition/2","title":"partisan_peer_service.inject_partition/2","type":"function"},{"doc":"","ref":"partisan_peer_service.html#join/1","title":"partisan_peer_service.join/1","type":"function"},{"doc":"Leave the cluster. We will not be able to re-join the cluster, we must be restarted first.","ref":"partisan_peer_service.html#leave/0","title":"partisan_peer_service.leave/0","type":"function"},{"doc":"Remove a node from the cluster. Subsequently calling join (NodeSpec) will not work for the removed node. The removed node must be restarted first.","ref":"partisan_peer_service.html#leave/1","title":"partisan_peer_service.leave/1","type":"function"},{"doc":"Return current peer service manager for this","ref":"partisan_peer_service.html#manager/0","title":"partisan_peer_service.manager/0","type":"function"},{"doc":"Return a sampling of nodes connected to this node. When using a full-mesh topology i.e. partisan_pluggable_peer_service_manager or partisan_static_peer_service_manager this is the set of all cluster members. However, if you're using other managers, the result will only be a sampling of the nodes.","ref":"partisan_peer_service.html#member/1","title":"partisan_peer_service.member/1","type":"function"},{"doc":"Return cluster members","ref":"partisan_peer_service.html#members/0","title":"partisan_peer_service.members/0","type":"function"},{"doc":"Return cluster members","ref":"partisan_peer_service.html#members_for_orchestration/0","title":"partisan_peer_service.members_for_orchestration/0","type":"function"},{"doc":"Trigger function on connection close for a given node. Function is a function object taking zero or a single argument, where the argument is the Node name. At the moment, this only works when using a full-mesh topology i.e. partisan_pluggable_peer_service_manager or partisan_static_peer_service_manager .","ref":"partisan_peer_service.html#on_down/2","title":"partisan_peer_service.on_down/2","type":"function"},{"doc":"Trigger function on connection close for a given node. Function is a function object taking zero or a single argument, where the argument is the Node name. At the moment, this only works when using a full-mesh topology i.e. partisan_pluggable_peer_service_manager or partisan_static_peer_service_manager .","ref":"partisan_peer_service.html#on_down/3","title":"partisan_peer_service.on_down/3","type":"function"},{"doc":"Trigger function on connection open for a given node. Function is a function object taking zero or a single argument, where the argument is the Node name. At the moment, this only works when using a full-mesh topology i.e. partisan_pluggable_peer_service_manager or partisan_static_peer_service_manager .","ref":"partisan_peer_service.html#on_up/2","title":"partisan_peer_service.on_up/2","type":"function"},{"doc":"Trigger function on connection open for a given node. Function is a function object taking zero or a single argument, where the argument is the Node name. At the moment, this only works when using a full-mesh topology i.e. partisan_pluggable_peer_service_manager or partisan_static_peer_service_manager .","ref":"partisan_peer_service.html#on_up/3","title":"partisan_peer_service.on_up/3","type":"function"},{"doc":"","ref":"partisan_peer_service.html#partitions/0","title":"partisan_peer_service.partitions/0","type":"function"},{"doc":"Reserve a slot for the particular tag.","ref":"partisan_peer_service.html#reserve/1","title":"partisan_peer_service.reserve/1","type":"function"},{"doc":"Resolve a partition.","ref":"partisan_peer_service.html#resolve_partition/1","title":"partisan_peer_service.resolve_partition/1","type":"function"},{"doc":"Stop","ref":"partisan_peer_service.html#stop/0","title":"partisan_peer_service.stop/0","type":"function"},{"doc":"Stop","ref":"partisan_peer_service.html#stop/1","title":"partisan_peer_service.stop/1","type":"function"},{"doc":"","ref":"partisan_peer_service.html#sync_join/1","title":"partisan_peer_service.sync_join/1","type":"function"},{"doc":"Update cluster members with a list of node specifications.","ref":"partisan_peer_service.html#update_members/1","title":"partisan_peer_service.update_members/1","type":"function"},{"doc":"","ref":"partisan_peer_service.html#t:ttl/0","title":"partisan_peer_service.ttl/0","type":"type"},{"doc":"This module is an adaptation of Erlang erpc module. It replaces all instances of erlang:send/2` and `erlang:monitor/2` with their Partisan counterparts. It maintains the `erpc API with the following exceptions: TODO - Channels NOTICE: At the moment this only works for partisan_pluggable_peer_service_manager .","ref":"partisan_erpc.html","title":"partisan_erpc","type":"module"},{"doc":"","ref":"partisan_erpc.html#call/2","title":"partisan_erpc.call/2","type":"function"},{"doc":"","ref":"partisan_erpc.html#call/3","title":"partisan_erpc.call/3","type":"function"},{"doc":"","ref":"partisan_erpc.html#call/4","title":"partisan_erpc.call/4","type":"function"},{"doc":"","ref":"partisan_erpc.html#call/5","title":"partisan_erpc.call/5","type":"function"},{"doc":"","ref":"partisan_erpc.html#call_result/4","title":"partisan_erpc.call_result/4","type":"function"},{"doc":"","ref":"partisan_erpc.html#cast/2","title":"partisan_erpc.cast/2","type":"function"},{"doc":"","ref":"partisan_erpc.html#cast/4","title":"partisan_erpc.cast/4","type":"function"},{"doc":"","ref":"partisan_erpc.html#check_response/2","title":"partisan_erpc.check_response/2","type":"function"},{"doc":"","ref":"partisan_erpc.html#execute_call/3","title":"partisan_erpc.execute_call/3","type":"function"},{"doc":"","ref":"partisan_erpc.html#execute_call/4","title":"partisan_erpc.execute_call/4","type":"function"},{"doc":"","ref":"partisan_erpc.html#execute_cast/3","title":"partisan_erpc.execute_cast/3","type":"function"},{"doc":"","ref":"partisan_erpc.html#is_arg_error/4","title":"partisan_erpc.is_arg_error/4","type":"function"},{"doc":"","ref":"partisan_erpc.html#multicall/2","title":"partisan_erpc.multicall/2","type":"function"},{"doc":"","ref":"partisan_erpc.html#multicall/3","title":"partisan_erpc.multicall/3","type":"function"},{"doc":"","ref":"partisan_erpc.html#multicall/4","title":"partisan_erpc.multicall/4","type":"function"},{"doc":"","ref":"partisan_erpc.html#multicall/5","title":"partisan_erpc.multicall/5","type":"function"},{"doc":"","ref":"partisan_erpc.html#multicast/2","title":"partisan_erpc.multicast/2","type":"function"},{"doc":"","ref":"partisan_erpc.html#multicast/4","title":"partisan_erpc.multicast/4","type":"function"},{"doc":"","ref":"partisan_erpc.html#receive_response/1","title":"partisan_erpc.receive_response/1","type":"function"},{"doc":"","ref":"partisan_erpc.html#receive_response/2","title":"partisan_erpc.receive_response/2","type":"function"},{"doc":"","ref":"partisan_erpc.html#send_request/2","title":"partisan_erpc.send_request/2","type":"function"},{"doc":"","ref":"partisan_erpc.html#send_request/4","title":"partisan_erpc.send_request/4","type":"function"},{"doc":"","ref":"partisan_erpc.html#trim_stack/4","title":"partisan_erpc.trim_stack/4","type":"function"},{"doc":"","ref":"partisan_erpc.html#wait_response/1","title":"partisan_erpc.wait_response/1","type":"function"},{"doc":"","ref":"partisan_erpc.html#wait_response/2","title":"partisan_erpc.wait_response/2","type":"function"},{"doc":"","ref":"partisan_erpc.html#t:caught_call_exception/0","title":"partisan_erpc.caught_call_exception/0","type":"type"},{"doc":"","ref":"partisan_erpc.html#t:request_id/0","title":"partisan_erpc.request_id/0","type":"opaque"},{"doc":"","ref":"partisan_erpc.html#t:stack_item/0","title":"partisan_erpc.stack_item/0","type":"type"},{"doc":"This module is responsible for monitoring processes on remote nodes and implementing the monitoring API provided by the partisan module which follows the API provided by the Erlang modules erlang and net_kernel . YOU SHOULD NEVER USE the functions in this module directly. Use the related functions in partisan instead. NOTICE At the moment this only works for partisan_pluggable_peer_service_manager backend. Also, certain partisan_peer_service_manager implementations might not support the partisan_peer_service_manager:on_up/2 and partisan_peer_service_manager:on_down/2 callbacks which we need for node monitoring, so in those cases this module will not work.","ref":"partisan_monitor.html","title":"partisan_monitor","type":"module"},{"doc":"","ref":"partisan_monitor.html#code_change/3","title":"partisan_monitor.code_change/3","type":"function"},{"doc":"Failure: notalive if the partisan_monitor process is not alive. not_implemented if the partisan peer service manager does not support the required capabilities required for monitoring. badarg if any of the arguments is invalid.","ref":"partisan_monitor.html#demonitor/2","title":"partisan_monitor.demonitor/2","type":"function"},{"doc":"","ref":"partisan_monitor.html#handle_call/3","title":"partisan_monitor.handle_call/3","type":"function"},{"doc":"","ref":"partisan_monitor.html#handle_cast/2","title":"partisan_monitor.handle_cast/2","type":"function"},{"doc":"","ref":"partisan_monitor.html#handle_info/2","title":"partisan_monitor.handle_info/2","type":"function"},{"doc":"","ref":"partisan_monitor.html#init/1","title":"partisan_monitor.init/1","type":"function"},{"doc":"When you attempt to monitor a remote process, it is not guaranteed that you will receive the DOWN message. A few reasons for not receiving the message are message loss and tree reconfiguration. The monitor options Opts are currently ignored. Failure: notalive If the partisan_monitor server process is not alive. not_implemented If the partisan peer service manager in use doesn't support the capabilities required for monitoring. badarg If any of the arguments are invalid.","ref":"partisan_monitor.html#monitor/2","title":"partisan_monitor.monitor/2","type":"function"},{"doc":"Monitor the status of the node Node . If Flag is true, monitoring is turned on. If Flag is false , monitoring is turned off. Making several calls to monitor_node(Node, true) for the same Node is not an error; it results in as many independent monitoring instances as the number of different calling processes i.e. If a process has made two calls to monitor_node(Node, true) and Node terminates, only one nodedown message is delivered to the process (this differs from erlang:monitor_node/2 ). If Node fails or does not exist, the message {nodedown, Node} is delivered to the calling process. If there is no connection to Node, a nodedown message is delivered. As a result when using a membership strategy that uses a partial view, you cannot monitor nodes that are not members of the view. Failure: notalive if the partisan_monitor process is not alive. not_implemented if the partisan peer service manager does not support the required capabilities required for monitoring. badarg if any of the arguments is invalid. This function is executed in the calling process.","ref":"partisan_monitor.html#monitor_node/2","title":"partisan_monitor.monitor_node/2","type":"function"},{"doc":"The calling process subscribes or unsubscribes to node status change messages. A nodeup message is delivered to all subscribing processes when a new node is connected, and a nodedown message is delivered when a node is disconnected. If Flag is true, a new subscription is started. If Flag is false, all previous subscriptions started with the same Options are stopped. Two option lists are considered the same if they contain the same set of options. Notice that the following two disterl guarantees are NOT yet provided by Partisan: nodeup messages are delivered before delivery of any message from the remote node passed through the newly established connection. nodedown messages are not delivered until all messages from the remote node that have been passed through the connection have been delivered. This function is executed in the calling process.","ref":"partisan_monitor.html#monitor_nodes/2","title":"partisan_monitor.monitor_nodes/2","type":"function"},{"doc":"Starts the partisan_monitor server. There is one partisan_monitor server instance per node.","ref":"partisan_monitor.html#start_link/0","title":"partisan_monitor.start_link/0","type":"function"},{"doc":"","ref":"partisan_monitor.html#terminate/2","title":"partisan_monitor.terminate/2","type":"function"},{"doc":"","ref":"partisan_monitor.html#t:node_mon/0","title":"partisan_monitor.node_mon/0","type":"type"},{"doc":"","ref":"partisan_monitor.html#t:node_type_mon/0","title":"partisan_monitor.node_type_mon/0","type":"type"},{"doc":"","ref":"partisan_monitor.html#t:node_type_mon_opts/0","title":"partisan_monitor.node_type_mon_opts/0","type":"type"},{"doc":"","ref":"partisan_monitor.html#t:proc_mon_in/0","title":"partisan_monitor.proc_mon_in/0","type":"type"},{"doc":"","ref":"partisan_monitor.html#t:proc_mon_in_idx/0","title":"partisan_monitor.proc_mon_in_idx/0","type":"type"},{"doc":"","ref":"partisan_monitor.html#t:proc_mon_out/0","title":"partisan_monitor.proc_mon_out/0","type":"type"},{"doc":"","ref":"partisan_monitor.html#t:proc_mon_out_idx/0","title":"partisan_monitor.proc_mon_out_idx/0","type":"type"},{"doc":"","ref":"partisan_rpc.html","title":"partisan_rpc","type":"module"},{"doc":"","ref":"partisan_rpc.html#call/4","title":"partisan_rpc.call/4","type":"function"},{"doc":"","ref":"partisan_rpc.html#call/5","title":"partisan_rpc.call/5","type":"function"},{"doc":"","ref":"partisan_rpc.html#prepare_opts/1","title":"partisan_rpc.prepare_opts/1","type":"function"},{"doc":"","ref":"partisan_rpc.html#t:error_reason/0","title":"partisan_rpc.error_reason/0","type":"type"},{"doc":"","ref":"partisan_rpc_backend.html","title":"partisan_rpc_backend","type":"module"},{"doc":"","ref":"partisan_rpc_backend.html#code_change/3","title":"partisan_rpc_backend.code_change/3","type":"function"},{"doc":"","ref":"partisan_rpc_backend.html#handle_call/3","title":"partisan_rpc_backend.handle_call/3","type":"function"},{"doc":"","ref":"partisan_rpc_backend.html#handle_cast/2","title":"partisan_rpc_backend.handle_cast/2","type":"function"},{"doc":"","ref":"partisan_rpc_backend.html#handle_info/2","title":"partisan_rpc_backend.handle_info/2","type":"function"},{"doc":"","ref":"partisan_rpc_backend.html#init/1","title":"partisan_rpc_backend.init/1","type":"function"},{"doc":"","ref":"partisan_rpc_backend.html#start_link/0","title":"partisan_rpc_backend.start_link/0","type":"function"},{"doc":"","ref":"partisan_rpc_backend.html#terminate/2","title":"partisan_rpc_backend.terminate/2","type":"function"},{"doc":"","ref":"partisan_test_server.html","title":"partisan_test_server","type":"module"},{"doc":"","ref":"partisan_test_server.html#call/0","title":"partisan_test_server.call/0","type":"function"},{"doc":"","ref":"partisan_test_server.html#call/1","title":"partisan_test_server.call/1","type":"function"},{"doc":"","ref":"partisan_test_server.html#cast/1","title":"partisan_test_server.cast/1","type":"function"},{"doc":"","ref":"partisan_test_server.html#cast/2","title":"partisan_test_server.cast/2","type":"function"},{"doc":"","ref":"partisan_test_server.html#crash/0","title":"partisan_test_server.crash/0","type":"function"},{"doc":"","ref":"partisan_test_server.html#delayed_reply_call/0","title":"partisan_test_server.delayed_reply_call/0","type":"function"},{"doc":"","ref":"partisan_test_server.html#delayed_reply_call/1","title":"partisan_test_server.delayed_reply_call/1","type":"function"},{"doc":"","ref":"partisan_test_server.html#is_alive/1","title":"partisan_test_server.is_alive/1","type":"function"},{"doc":"","ref":"partisan_test_server.html#reply_crash/0","title":"partisan_test_server.reply_crash/0","type":"function"},{"doc":"","ref":"partisan_test_server.html#start_link/0","title":"partisan_test_server.start_link/0","type":"function"},{"doc":"This state machine is responsible for enabled cluster peers using the defined implementation backend (callback module).","ref":"partisan_peer_discovery_agent.html","title":"partisan_peer_discovery_agent","type":"behaviour"},{"doc":"","ref":"partisan_peer_discovery_agent.html#callback_mode/0","title":"partisan_peer_discovery_agent.callback_mode/0","type":"function"},{"doc":"","ref":"partisan_peer_discovery_agent.html#code_change/4","title":"partisan_peer_discovery_agent.code_change/4","type":"function"},{"doc":"","ref":"partisan_peer_discovery_agent.html#disable/0","title":"partisan_peer_discovery_agent.disable/0","type":"function"},{"doc":"","ref":"partisan_peer_discovery_agent.html#disabled/3","title":"partisan_peer_discovery_agent.disabled/3","type":"function"},{"doc":"","ref":"partisan_peer_discovery_agent.html#enable/0","title":"partisan_peer_discovery_agent.enable/0","type":"function"},{"doc":"In this state the agent uses the callback module to discover peers by calling its lookup/2 callback.","ref":"partisan_peer_discovery_agent.html#enabled/3","title":"partisan_peer_discovery_agent.enabled/3","type":"function"},{"doc":"","ref":"partisan_peer_discovery_agent.html#format_status/2","title":"partisan_peer_discovery_agent.format_status/2","type":"function"},{"doc":"","ref":"partisan_peer_discovery_agent.html#init/1","title":"partisan_peer_discovery_agent.init/1","type":"function"},{"doc":"","ref":"partisan_peer_discovery_agent.html#c:init/1","title":"partisan_peer_discovery_agent.init/1","type":"callback"},{"doc":"","ref":"partisan_peer_discovery_agent.html#lookup/0","title":"partisan_peer_discovery_agent.lookup/0","type":"function"},{"doc":"","ref":"partisan_peer_discovery_agent.html#c:lookup/2","title":"partisan_peer_discovery_agent.lookup/2","type":"callback"},{"doc":"","ref":"partisan_peer_discovery_agent.html#start/0","title":"partisan_peer_discovery_agent.start/0","type":"function"},{"doc":"","ref":"partisan_peer_discovery_agent.html#start_link/0","title":"partisan_peer_discovery_agent.start_link/0","type":"function"},{"doc":"","ref":"partisan_peer_discovery_agent.html#status/0","title":"partisan_peer_discovery_agent.status/0","type":"function"},{"doc":"","ref":"partisan_peer_discovery_agent.html#terminate/3","title":"partisan_peer_discovery_agent.terminate/3","type":"function"},{"doc":"An implementation of the partisan_peer_discovery_agent behaviour that uses DNS for service discovery. It is enabled by using the following options in the sys.conf file bash { partisan , [ { peer_discovery , [ { type , partisan_peer_discovery_dns } , { config , \#{ record_type =&gt; fqdns , name =&gt; &quot;theDNSSearchName&quot; , nodename =&gt; &quot;foo&quot; } } ] } ] }","ref":"partisan_peer_discovery_dns.html","title":"partisan_peer_discovery_dns","type":"module"},{"doc":"","ref":"partisan_peer_discovery_dns.html#init/1","title":"partisan_peer_discovery_dns.init/1","type":"function"},{"doc":"","ref":"partisan_peer_discovery_dns.html#lookup/2","title":"partisan_peer_discovery_dns.lookup/2","type":"function"},{"doc":"","ref":"partisan_peer_discovery_dns.html#t:options/0","title":"partisan_peer_discovery_dns.options/0","type":"type"},{"doc":"An implementation of the partisan_peer_discovery_agent behaviour that uses a static list of node names for service discovery. It is enabled by using the following options in the sys.conf file bash { partisan , [ { peer_discovery , [ { type , partisan_peer_discovery_list } , { config , \#{ name =&gt; mynode nodes =&gt; [ &lt;&lt; &quot;192.168.40.1:9000&quot; &gt;&gt; , &lt;&lt; &quot;192.168.40.10:9000&quot; &gt;&gt; , &lt;&lt; &quot;mynode@192.168.40.100:9000&quot; &gt;&gt; , ] } } ] } ] }","ref":"partisan_peer_discovery_list.html","title":"partisan_peer_discovery_list","type":"module"},{"doc":"","ref":"partisan_peer_discovery_list.html#init/1","title":"partisan_peer_discovery_list.init/1","type":"function"},{"doc":"","ref":"partisan_peer_discovery_list.html#lookup/2","title":"partisan_peer_discovery_list.lookup/2","type":"function"},{"doc":"","ref":"partisan_peer_discovery_list.html#t:name/0","title":"partisan_peer_discovery_list.name/0","type":"type"},{"doc":"","ref":"partisan_peer_discovery_list.html#t:options/0","title":"partisan_peer_discovery_list.options/0","type":"type"},{"doc":"","ref":"partisan_peer_discovery_list.html#t:state/0","title":"partisan_peer_discovery_list.state/0","type":"type"},{"doc":"","ref":"partisan_peer_service_client.html","title":"partisan_peer_service_client","type":"module"},{"doc":"","ref":"partisan_peer_service_client.html#code_change/3","title":"partisan_peer_service_client.code_change/3","type":"function"},{"doc":"Test harness specific. If we're running a local test, we have to use the same IP address for every bind operation, but a different port instead of the standard port.","ref":"partisan_peer_service_client.html#connect/3","title":"partisan_peer_service_client.connect/3","type":"function"},{"doc":"","ref":"partisan_peer_service_client.html#handle_call/3","title":"partisan_peer_service_client.handle_call/3","type":"function"},{"doc":"","ref":"partisan_peer_service_client.html#handle_cast/2","title":"partisan_peer_service_client.handle_cast/2","type":"function"},{"doc":"","ref":"partisan_peer_service_client.html#handle_info/2","title":"partisan_peer_service_client.handle_info/2","type":"function"},{"doc":"","ref":"partisan_peer_service_client.html#init/1","title":"partisan_peer_service_client.init/1","type":"function"},{"doc":"Start and link to calling process. If the process is started and can get a connection it returns {ok, pid()} . Otherwise if it fails with {error, Reason :: any()} .","ref":"partisan_peer_service_client.html#start_link/5","title":"partisan_peer_service_client.start_link/5","type":"function"},{"doc":"","ref":"partisan_peer_service_client.html#terminate/2","title":"partisan_peer_service_client.terminate/2","type":"function"},{"doc":"","ref":"partisan_peer_service_client.html#t:state/0","title":"partisan_peer_service_client.state/0","type":"type"},{"doc":"","ref":"partisan_peer_service_console.html","title":"partisan_peer_service_console","type":"module"},{"doc":"","ref":"partisan_peer_service_console.html#members/1","title":"partisan_peer_service_console.members/1","type":"function"},{"doc":"","ref":"partisan_peer_service_console.html#print_members/1","title":"partisan_peer_service_console.print_members/1","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html","title":"partisan_peer_service_events","type":"module"},{"doc":"","ref":"partisan_peer_service_events.html#add_callback/1","title":"partisan_peer_service_events.add_callback/1","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html#add_handler/2","title":"partisan_peer_service_events.add_handler/2","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html#add_sup_callback/1","title":"partisan_peer_service_events.add_sup_callback/1","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html#add_sup_handler/2","title":"partisan_peer_service_events.add_sup_handler/2","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html#code_change/3","title":"partisan_peer_service_events.code_change/3","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html#handle_call/2","title":"partisan_peer_service_events.handle_call/2","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html#handle_event/2","title":"partisan_peer_service_events.handle_event/2","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html#handle_info/2","title":"partisan_peer_service_events.handle_info/2","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html#init/1","title":"partisan_peer_service_events.init/1","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html#start_link/0","title":"partisan_peer_service_events.start_link/0","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html#terminate/2","title":"partisan_peer_service_events.terminate/2","type":"function"},{"doc":"","ref":"partisan_peer_service_events.html#update/1","title":"partisan_peer_service_events.update/1","type":"function"},{"doc":"","ref":"partisan_peer_service_manager.html","title":"partisan_peer_service_manager","type":"behaviour"},{"doc":"","ref":"partisan_peer_service_manager.html#c:cast_message/2","title":"partisan_peer_service_manager.cast_message/2","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:cast_message/3","title":"partisan_peer_service_manager.cast_message/3","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:cast_message/4","title":"partisan_peer_service_manager.cast_message/4","type":"callback"},{"doc":"Tries to create a new connection to a node, but only if required. If successful it stores the new connection record in the partisan_peer_connections table. This function calls connect/2 with options \#{prune =&gt; false} .","ref":"partisan_peer_service_manager.html#connect/1","title":"partisan_peer_service_manager.connect/1","type":"function"},{"doc":"Create a new connection to a node specified by NodeSpec and options Opts . If a new connection is created it will be stored in the partisan_peer_connections table. If option prune is true returns the tuple {ok, L :: [ partisan:node_spec()]} where list L is the list of nodes specifications for all stale nodes. Otherwise returns ok . A specification is stale if there is another specification for the same node for which we already have one or more active connections. A stale specification will exist when a node has crashed (without leaving the cluster) and later on returned with a different IP address i.e. a normal situation on cloud orchestration platforms. In this case the membership set ( partisan_membership_set ) will have two node specifications for the same node (with differing values for the listen_addrs property). See the section **Stale Specifications** in partisan_membership_set .","ref":"partisan_peer_service_manager.html#connect/2","title":"partisan_peer_service_manager.connect/2","type":"function"},{"doc":"","ref":"partisan_peer_service_manager.html#c:decode/1","title":"partisan_peer_service_manager.decode/1","type":"callback"},{"doc":"Kill all connections with node in Nodes and for each call function Fun passing the node as argument","ref":"partisan_peer_service_manager.html#disconnect/1","title":"partisan_peer_service_manager.disconnect/1","type":"function"},{"doc":"Kill all connections with node in Nodes and for each call function Fun passing the node as argument","ref":"partisan_peer_service_manager.html#disconnect/2","title":"partisan_peer_service_manager.disconnect/2","type":"function"},{"doc":"","ref":"partisan_peer_service_manager.html#c:forward_message/2","title":"partisan_peer_service_manager.forward_message/2","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:forward_message/3","title":"partisan_peer_service_manager.forward_message/3","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:forward_message/4","title":"partisan_peer_service_manager.forward_message/4","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:get_local_state/0","title":"partisan_peer_service_manager.get_local_state/0","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:inject_partition/2","title":"partisan_peer_service_manager.inject_partition/2","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:join/1","title":"partisan_peer_service_manager.join/1","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:leave/0","title":"partisan_peer_service_manager.leave/0","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:leave/1","title":"partisan_peer_service_manager.leave/1","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:members/0","title":"partisan_peer_service_manager.members/0","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:members_for_orchestration/0","title":"partisan_peer_service_manager.members_for_orchestration/0","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#mynode/0","title":"partisan_peer_service_manager.mynode/0","type":"function"},{"doc":"","ref":"partisan_peer_service_manager.html#myself/0","title":"partisan_peer_service_manager.myself/0","type":"function"},{"doc":"","ref":"partisan_peer_service_manager.html#c:on_down/2","title":"partisan_peer_service_manager.on_down/2","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:on_down/3","title":"partisan_peer_service_manager.on_down/3","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:on_up/2","title":"partisan_peer_service_manager.on_up/2","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:on_up/3","title":"partisan_peer_service_manager.on_up/3","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:partitions/0","title":"partisan_peer_service_manager.partitions/0","type":"callback"},{"doc":"Internal function used by peer_service manager implementations to forward a message to a process identified by ServerRef that is either local or located at remote process when the remote node is connected via disterl. Trying to send a message to a remote server reference when the process is located at a node connected with Partisan will return ok but will not succeed.","ref":"partisan_peer_service_manager.html#process_forward/2","title":"partisan_peer_service_manager.process_forward/2","type":"function"},{"doc":"","ref":"partisan_peer_service_manager.html#c:receive_message/3","title":"partisan_peer_service_manager.receive_message/3","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:reserve/1","title":"partisan_peer_service_manager.reserve/1","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:resolve_partition/1","title":"partisan_peer_service_manager.resolve_partition/1","type":"callback"},{"doc":"Send a message to a remote peer_service_manager.","ref":"partisan_peer_service_manager.html#send_message/2","title":"partisan_peer_service_manager.send_message/2","type":"function"},{"doc":"","ref":"partisan_peer_service_manager.html#c:send_message/2","title":"partisan_peer_service_manager.send_message/2","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:start_link/0","title":"partisan_peer_service_manager.start_link/0","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:supports_capability/1","title":"partisan_peer_service_manager.supports_capability/1","type":"callback"},{"doc":"If Mod implements callback supports_capability/1 returns the result of calling the callback passing argument Arg . Otherwise, returns false .","ref":"partisan_peer_service_manager.html#supports_capability/2","title":"partisan_peer_service_manager.supports_capability/2","type":"function"},{"doc":"","ref":"partisan_peer_service_manager.html#c:sync_join/1","title":"partisan_peer_service_manager.sync_join/1","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#c:update_members/1","title":"partisan_peer_service_manager.update_members/1","type":"callback"},{"doc":"","ref":"partisan_peer_service_manager.html#t:connect_opts/0","title":"partisan_peer_service_manager.connect_opts/0","type":"type"},{"doc":"","ref":"partisan_peer_service_manager.html#t:forward_opts/0","title":"partisan_peer_service_manager.forward_opts/0","type":"type"},{"doc":"","ref":"partisan_peer_service_manager.html#t:on_event_fun/0","title":"partisan_peer_service_manager.on_event_fun/0","type":"type"},{"doc":"","ref":"partisan_peer_service_manager.html#t:partitions/0","title":"partisan_peer_service_manager.partitions/0","type":"type"},{"doc":"","ref":"partisan_peer_service_manager.html#t:server_ref/0","title":"partisan_peer_service_manager.server_ref/0","type":"type"},{"doc":"","ref":"partisan_peer_service_server.html","title":"partisan_peer_service_server","type":"module"},{"doc":"","ref":"partisan_peer_service_server.html#acceptor_continue/3","title":"partisan_peer_service_server.acceptor_continue/3","type":"function"},{"doc":"","ref":"partisan_peer_service_server.html#acceptor_init/3","title":"partisan_peer_service_server.acceptor_init/3","type":"function"},{"doc":"","ref":"partisan_peer_service_server.html#acceptor_terminate/2","title":"partisan_peer_service_server.acceptor_terminate/2","type":"function"},{"doc":"","ref":"partisan_peer_service_server.html#code_change/3","title":"partisan_peer_service_server.code_change/3","type":"function"},{"doc":"","ref":"partisan_peer_service_server.html#handle_call/3","title":"partisan_peer_service_server.handle_call/3","type":"function"},{"doc":"","ref":"partisan_peer_service_server.html#handle_cast/2","title":"partisan_peer_service_server.handle_cast/2","type":"function"},{"doc":"","ref":"partisan_peer_service_server.html#handle_info/2","title":"partisan_peer_service_server.handle_info/2","type":"function"},{"doc":"","ref":"partisan_peer_service_server.html#handle_message/2","title":"partisan_peer_service_server.handle_message/2","type":"function"},{"doc":"","ref":"partisan_peer_service_server.html#init/1","title":"partisan_peer_service_server.init/1","type":"function"},{"doc":"","ref":"partisan_peer_service_server.html#terminate/2","title":"partisan_peer_service_server.terminate/2","type":"function"},{"doc":"","ref":"partisan_peer_service_server.html#t:state_t/0","title":"partisan_peer_service_server.state_t/0","type":"type"},{"doc":"","ref":"partisan_peer_service_sup.html","title":"partisan_peer_service_sup","type":"module"},{"doc":"","ref":"partisan_peer_service_sup.html#init/1","title":"partisan_peer_service_sup.init/1","type":"function"},{"doc":"","ref":"partisan_peer_service_sup.html#start_link/0","title":"partisan_peer_service_sup.start_link/0","type":"function"},{"doc":"Remote references are Partisan's representation for remote process identifiers ( pid() ), registered names and references ( reference() ). Distributed Erlang (disterl) will transform the representation of process identifiers, registered names and references when they are sent to a remote node. This is done to disambiguate between remote and local instances. Because Partisan doesn't use disterl it needs to implement this same disambiguation mechanism somehow. As disterl's implementation is done by the BEAM internally and not API is exposed, this module is required to achieve a similar result. Representation In cases where lots of references are stored in process state, ets and specially where those are uses as keys, a binary format is preferable to the tuple format in order to save memory and avoid copying the term every time a message is send between processes (by leveraging off-heap binary storage). For this reason, this module implements two alternative representations: references as binary URIs references as tuples The representation to use is controlled by the configuration option remote_ref_as_uri`. If `true this module will generate references as binary URIs. Otherwise it will generate them as tuples.r URI Representation 1 &gt; partisan_remote_ref : from_term ( self ( ) ) . &lt;&lt; &quot;partisan:pid:nonode@nohost:0.1062.0&quot; &gt;&gt; URI Padding For those cases where the resulting references are smaller than 64 bytes ( and thus will be stored on the process heap) this module can pad the generated binary URIs to 65 bytes, thus forcing them to be stored off-heap. This is controlled with the configuration option remote_ref_binary_padding . 1 &gt; partisan_config : set ( remote_ref_binary_padding , false ) . 2 &gt; partisan_remote_ref : from_term ( self ( ) ) . &lt;&lt; &quot;partisan:pid:nonode@nohost:0.1062.0&quot; &gt;&gt; 3 &gt; partisan_config : set ( remote_ref_binary_padding , true ) . ok 4 &gt; partisan_remote_ref : from_term ( self ( ) ) . &lt;&lt; &quot;partisan:pid:nonode@nohost:0.1062.0:&quot; . . . &gt;&gt; Tuple Representation 1 &gt; partisan_remote_ref : from_term ( self ( ) ) . { partisan_remote_reference , nonode @ nohost , { partisan_process_reference , &quot;&lt;0.1062.0&gt;&quot; } } Issues and TODOs As opposed to erlang pid encodintg ( NEW_PID_EXT`) our current representation cannot distinguished between identifiers from old (crashed) nodes from a new one. So maybe we need to adopt the `NEW_PID_EXT Creation attribute.","ref":"partisan_remote_ref.html","title":"partisan_remote_ref","type":"module"},{"doc":"Returns the partisan-encoded representation of a process identifier, reference, local or remote registered name (atom). In the case of a name, the function does not check Name is an actual registered name.","ref":"partisan_remote_ref.html#from_term/1","title":"partisan_remote_ref.from_term/1","type":"function"},{"doc":"Returns the partisan-encoded representation of a registered name Name at node Node . The function does not check Name is an actual registered name,","ref":"partisan_remote_ref.html#from_term/2","title":"partisan_remote_ref.from_term/2","type":"function"},{"doc":"Checks two refs for identity. Two refs are identical if the are equal or if one is a process reference and the other one is a registered name reference of said process. In the latter case the function uses erlang:whereis/1 which means the check can fail if the process has died (and thus is no longer registered).","ref":"partisan_remote_ref.html#is_identical/2","title":"partisan_remote_ref.is_identical/2","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_local/1","title":"partisan_remote_ref.is_local/1","type":"function"},{"doc":"Returns true if reference Ref is located in node Node .","ref":"partisan_remote_ref.html#is_local/2","title":"partisan_remote_ref.is_local/2","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_local_name/1","title":"partisan_remote_ref.is_local_name/1","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_local_name/2","title":"partisan_remote_ref.is_local_name/2","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_local_pid/1","title":"partisan_remote_ref.is_local_pid/1","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_local_pid/2","title":"partisan_remote_ref.is_local_pid/2","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_local_reference/1","title":"partisan_remote_ref.is_local_reference/1","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_local_reference/2","title":"partisan_remote_ref.is_local_reference/2","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_name/1","title":"partisan_remote_ref.is_name/1","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_name/2","title":"partisan_remote_ref.is_name/2","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_pid/1","title":"partisan_remote_ref.is_pid/1","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_reference/1","title":"partisan_remote_ref.is_reference/1","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#is_type/1","title":"partisan_remote_ref.is_type/1","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#node/1","title":"partisan_remote_ref.node/1","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#nodestring/1","title":"partisan_remote_ref.nodestring/1","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#target/1","title":"partisan_remote_ref.target/1","type":"function"},{"doc":"Calls to_term/1 and returns the result if it is an local name i.e. atom(). Otherwise fails with badarg","ref":"partisan_remote_ref.html#to_name/1","title":"partisan_remote_ref.to_name/1","type":"function"},{"doc":"Calls to_term/1 and returns the result if it is a local pid(). Otherwise fails with badarg","ref":"partisan_remote_ref.html#to_pid/1","title":"partisan_remote_ref.to_pid/1","type":"function"},{"doc":"Calls to_term/1 and returns the result if it is an local name i.e. atom() or local pid(). Otherwise fails with badarg","ref":"partisan_remote_ref.html#to_pid_or_name/1","title":"partisan_remote_ref.to_pid_or_name/1","type":"function"},{"doc":"Calls to_term/1 and returns the result if it is a local reference(). Otherwise fails with badarg","ref":"partisan_remote_ref.html#to_reference/1","title":"partisan_remote_ref.to_reference/1","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#to_term/1","title":"partisan_remote_ref.to_term/1","type":"function"},{"doc":"","ref":"partisan_remote_ref.html#t:encoded_name/0","title":"partisan_remote_ref.encoded_name/0","type":"type"},{"doc":"","ref":"partisan_remote_ref.html#t:encoded_pid/0","title":"partisan_remote_ref.encoded_pid/0","type":"type"},{"doc":"","ref":"partisan_remote_ref.html#t:encoded_ref/0","title":"partisan_remote_ref.encoded_ref/0","type":"type"},{"doc":"","ref":"partisan_remote_ref.html#t:format/0","title":"partisan_remote_ref.format/0","type":"type"},{"doc":"","ref":"partisan_remote_ref.html#t:n/0","title":"partisan_remote_ref.n/0","type":"type"},{"doc":"","ref":"partisan_remote_ref.html#t:p/0","title":"partisan_remote_ref.p/0","type":"type"},{"doc":"","ref":"partisan_remote_ref.html#t:r/0","title":"partisan_remote_ref.r/0","type":"type"},{"doc":"","ref":"partisan_remote_ref.html#t:t/0","title":"partisan_remote_ref.t/0","type":"type"},{"doc":"","ref":"partisan_remote_ref.html#t:target/0","title":"partisan_remote_ref.target/0","type":"type"},{"doc":"","ref":"partisan_remote_ref.html#t:tuple_ref/1","title":"partisan_remote_ref.tuple_ref/1","type":"type"},{"doc":"","ref":"partisan_remote_ref.html#t:uri/0","title":"partisan_remote_ref.uri/0","type":"type"},{"doc":"This module realises the partisan_peer_service_manager behaviour implementing client-server topology where clients communicate with a single server and servers form a full-mesh topology. Characteristics Uses TCP/IP. Client nodes communicate and maintain connections with server nodes. They refuse connections from other clients but refer them to a server node. Server nodes communicate and maintain connections with all other server nodes. Nodes periodically send heartbeat messages. The service considers a node &quot;failed&quot; when it misses X heartbeats. Point-to-point messaging through the server (server as relay). Eventually consistent membership maintained in a CRDT and replicated using gossip. Scalability limited to hundres of nodes (60-200 nodes).","ref":"partisan_client_server_peer_service_manager.html","title":"partisan_client_server_peer_service_manager","type":"module"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#cast_message/2","title":"partisan_client_server_peer_service_manager.cast_message/2","type":"function"},{"doc":"Cast a message to a remote gen_server.","ref":"partisan_client_server_peer_service_manager.html#cast_message/3","title":"partisan_client_server_peer_service_manager.cast_message/3","type":"function"},{"doc":"Cast a message to a remote gen_server.","ref":"partisan_client_server_peer_service_manager.html#cast_message/4","title":"partisan_client_server_peer_service_manager.cast_message/4","type":"function"},{"doc":"Decode state.","ref":"partisan_client_server_peer_service_manager.html#decode/1","title":"partisan_client_server_peer_service_manager.decode/1","type":"function"},{"doc":"Gensym support for forwarding.","ref":"partisan_client_server_peer_service_manager.html#forward_message/2","title":"partisan_client_server_peer_service_manager.forward_message/2","type":"function"},{"doc":"Gensym support for forwarding.","ref":"partisan_client_server_peer_service_manager.html#forward_message/3","title":"partisan_client_server_peer_service_manager.forward_message/3","type":"function"},{"doc":"Forward message to registered process on the remote side.","ref":"partisan_client_server_peer_service_manager.html#forward_message/4","title":"partisan_client_server_peer_service_manager.forward_message/4","type":"function"},{"doc":"Return local node's view of cluster membership.","ref":"partisan_client_server_peer_service_manager.html#get_local_state/0","title":"partisan_client_server_peer_service_manager.get_local_state/0","type":"function"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#handle_call/3","title":"partisan_client_server_peer_service_manager.handle_call/3","type":"function"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#handle_cast/2","title":"partisan_client_server_peer_service_manager.handle_cast/2","type":"function"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#handle_info/2","title":"partisan_client_server_peer_service_manager.handle_info/2","type":"function"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#init/1","title":"partisan_client_server_peer_service_manager.init/1","type":"function"},{"doc":"Inject a partition.","ref":"partisan_client_server_peer_service_manager.html#inject_partition/2","title":"partisan_client_server_peer_service_manager.inject_partition/2","type":"function"},{"doc":"Attempt to join a remote node.","ref":"partisan_client_server_peer_service_manager.html#join/1","title":"partisan_client_server_peer_service_manager.join/1","type":"function"},{"doc":"Leave the cluster.","ref":"partisan_client_server_peer_service_manager.html#leave/0","title":"partisan_client_server_peer_service_manager.leave/0","type":"function"},{"doc":"Remove another node from the cluster.","ref":"partisan_client_server_peer_service_manager.html#leave/1","title":"partisan_client_server_peer_service_manager.leave/1","type":"function"},{"doc":"Return membership list.","ref":"partisan_client_server_peer_service_manager.html#members/0","title":"partisan_client_server_peer_service_manager.members/0","type":"function"},{"doc":"Return membership list.","ref":"partisan_client_server_peer_service_manager.html#members_for_orchestration/0","title":"partisan_client_server_peer_service_manager.members_for_orchestration/0","type":"function"},{"doc":"Trigger function on connection close for a given node. Fun is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_client_server_peer_service_manager.html#on_down/2","title":"partisan_client_server_peer_service_manager.on_down/2","type":"function"},{"doc":"Trigger function on connection close for a given node. Fun is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_client_server_peer_service_manager.html#on_down/3","title":"partisan_client_server_peer_service_manager.on_down/3","type":"function"},{"doc":"Trigger function on connection open for a given node. Fun is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_client_server_peer_service_manager.html#on_up/2","title":"partisan_client_server_peer_service_manager.on_up/2","type":"function"},{"doc":"Trigger function on connection open for a given node. Fun is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_client_server_peer_service_manager.html#on_up/3","title":"partisan_client_server_peer_service_manager.on_up/3","type":"function"},{"doc":"Return partitions.","ref":"partisan_client_server_peer_service_manager.html#partitions/0","title":"partisan_client_server_peer_service_manager.partitions/0","type":"function"},{"doc":"Receive message from a remote manager.","ref":"partisan_client_server_peer_service_manager.html#receive_message/3","title":"partisan_client_server_peer_service_manager.receive_message/3","type":"function"},{"doc":"Reserve a slot for the particular tag.","ref":"partisan_client_server_peer_service_manager.html#reserve/1","title":"partisan_client_server_peer_service_manager.reserve/1","type":"function"},{"doc":"Resolve a partition.","ref":"partisan_client_server_peer_service_manager.html#resolve_partition/1","title":"partisan_client_server_peer_service_manager.resolve_partition/1","type":"function"},{"doc":"Send message to a remote manager.","ref":"partisan_client_server_peer_service_manager.html#send_message/2","title":"partisan_client_server_peer_service_manager.send_message/2","type":"function"},{"doc":"Same as start_link([]).","ref":"partisan_client_server_peer_service_manager.html#start_link/0","title":"partisan_client_server_peer_service_manager.start_link/0","type":"function"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#supports_capability/1","title":"partisan_client_server_peer_service_manager.supports_capability/1","type":"function"},{"doc":"Attempt to join a remote node.","ref":"partisan_client_server_peer_service_manager.html#sync_join/1","title":"partisan_client_server_peer_service_manager.sync_join/1","type":"function"},{"doc":"Update membership.","ref":"partisan_client_server_peer_service_manager.html#update_members/1","title":"partisan_client_server_peer_service_manager.update_members/1","type":"function"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#t:call/0","title":"partisan_client_server_peer_service_manager.call/0","type":"type"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#t:cast/0","title":"partisan_client_server_peer_service_manager.cast/0","type":"type"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#t:membership/0","title":"partisan_client_server_peer_service_manager.membership/0","type":"type"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#t:on_event_fun/0","title":"partisan_client_server_peer_service_manager.on_event_fun/0","type":"type"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#t:pending/0","title":"partisan_client_server_peer_service_manager.pending/0","type":"type"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#t:state/0","title":"partisan_client_server_peer_service_manager.state/0","type":"type"},{"doc":"","ref":"partisan_client_server_peer_service_manager.html#t:tag/0","title":"partisan_client_server_peer_service_manager.tag/0","type":"type"},{"doc":"This module realises the partisan_peer_service_manager behaviour implementing a peer-to-peer partial mesh topology using the protocol described in the paper HyParView: a membership protocol for reliable gossip-based broadcast by João Leitão, José Pereira and Luís Rodrigues. The following content contains abstracts from the paper. Characteristics Uses TCP/IP as an unreliable failure detector (unreliable because it can generate false positives e.g. when the network becomes suddenly congested). It can sustain high level of node failres while ensuring connectivity of the overlay. Nodes are considered &quot;failed&quot; when the TCP/IP connection is dropped. Nodes maintain partial views of the network. Every node will contain and active view that forms a connected grah, and a passive view of backup links that are used to repair graph connectivity under failure. Some links to passive nodes are kept open for fast replacement of failed nodes in the active view. So the view is probabilistic, meaning that the protocol doesn't prevent (nor detects) the cluter to be split into several subclusters with no connections to each other. HyParView sacrificies strong membership for high availability and connectivity: the algorithm constantly works towards and ensures that eventually the clsuter membership is a fully-connected component. However, at any point in time different nodes may have different, inconsistent views of the cluster membership. As a consequence, HyParView is not designed to work with systems that require strong membership properties, eg. consensus protocols like Paxos or Raft. Point-to-point messaging for connected nodes with a minimum of 1 hop via transitive message delivery (as not all nodes directly connected). Delivery is probabilistic. No explicit leave operation, because the overlay is able to react fast enough to node failures. Hence when a node wishes to leave the system it is simply treated as if the node have failed. Scalability to up-to 2,000 nodes. HyParView Membership Protocol Partial View A partial view is a small subset of the entire system (cluster) membership, a set of node specifications maintained locally at each node. A node specification i.e. partisan:node_spec/0 allows a node to be reached by other nodes. A membership protocol is in charge of initializing and maintaining the partial views at each node in face of dynamic changes in the system. For instance, when a new node joins the system, its identifier should be added to the partial view of (some) other nodes and it has to create its own partial view, including identifiers of nodes already in the system. Also, if a node fails or leaves the system, its identifier should be removed from all partial views as soon as possible. Partial views establish neighboring associations among nodes. Therefore, partial views define an overlay network, in other words, partial views establish an directed graph that captures the neighbor relation between all nodes executing the protocol. In this graph nodes are represented by a vertex while a neighbor relation is represented by an arc from the node who contains the target node in his partial view. Membership Protocol The Hybrid Partial View (HyParView) membership protocol is in charge of maintaining two distinct views at each node: a small active view, of size log(n) + c , and a larger passive view, of size k(log(n) + c) . It then selects which members of this view should be promoted to the active view. Active View Each node maintains a small symmetric ctive view the size of fanout + 1. Being symmetric means means that if node q is in the active view of node p then node p is also in the active view of node q . The active views af all cluster nodes create an overlay that is used for message dissemination. Each node keeps an open TCP connection to every other node in its active view. Broadcast is performed deterministically by flooding the graph defined by the active views across the cluster. When a node receives a message for the first time, it broadcasts the message to all nodes of its active view ( except, obviously, to the node that has sent the message). While this graph is generated at random, gossip is deterministic as long as the graph remains unchanged. Active View Management A reactive strategy is used to maintain the active view. Nodes can be added to the active view when they join the system. Also, nodes are removed from the active view when they fail. When a node p suspects that one of the nodes present in its active view has failed (by either disconnecting or blocking), it selects a random node q from its passive view and attempts to establish a TCP connection with q . If the connection fails to establish, node q is considered failed and removed from p’s passive view; another node q′ is selected at random and a new attempt is made. When the connection is established with success, p sends to q a Neighbor request with its own identifier and a priority level. The priority level of the request may take two values, depending on the number of nodes present in the active view of p: if p has no elements in its active view the priority is high; the priority is low otherwise. A node q that receives a high priority neighbor request will always accept the request, even if it has to drop a random member from its active view ( again, the member that is dropped will receive a Disconnect notification). If a node q receives a low priority Neighbor request, it will only accept the request if it has a free slot in its active view, otherwise it will refuse the request. If the node q accepts the Neighbor request, p will remove q’s identifier from its passive view and add it to the active view. If q rejects the Neighbor request, the initiator will select another node from its passive view and repeat the whole procedure (without removing q from its passive view). Each node tests its entire active view every time it forwards a message. Therefore, the entire broadcast overlay is implicitly tested at every broadcast, which allows a very fast failure detection. Passive View In addition to the active view, each node maintains a larger passive view of backup nodes that can be promoted to the active view when one of the nodes in the active view fails. The passive view is not used for message dissemination. Instead, the goal of the passive view is to maintain a list of nodes that can be used to replace failed members of the active view. The passive view is maintained using a cyclic strategy. Periodically, each node performs a shuffle operation with one of its neighbors in order to update its passive view. Passive View Management The passive view is maintained using a cyclic strategy. Periodically, each node perform a shuffle operation with one of its peers at random. The purpose of the shuffle operation is to update the passive views of the nodes involved in the exchange. The node p that initiates the exchange creates an exchange list with the following contents: p’s own identifier, ka nodes from its active view and kp nodes from its passive view (where ka and kp are protocol parameters). It then sends the list in a Shuffle request to a random neighbor of its active view. Shuffle requests are propagated using a random walk and have an associated “time to live”, just like the ForwardJoin requests. A node q that receives a Shuffle request will first decrease its time to live. If the time to live of the message is greater than zero and the number of nodes in q’s active view is greater than 1, the node will select a random node from its active view, different from the one he received this shuffle message from, and simply forwards the Shuffle request. Otherwise, node q accepts the Shuffle request and send back, using a temporary TCP connection, a ShuffleReply message that includes a number of nodes selected at random from q’s passive view equal to the number of nodes received in the Shuffle request. Then, both nodes integrate the elements they received in the Shuffle/ ShuffleReply mes- sage into their passive views (naturally, they exclude their own identifier and nodes that are part of the active or passive views). Because the passive view has a fixed length, it might get full; in that case, some identifiers will have to be removed in order to free space to include the new ones. A node will first attempt to remove identifiers sent to the peer. If no such identifiers remain in the passive view, it will remove identifiers at random. Configuration The following are the HyParView configuration parameters managed by partisan_config . The params are passed as {hyparview, Config} where Config is a property list or map where the keys are the following: active_max_size Defaults to 6. active_min_size Defaults to 3. active_rwl Active View Random Walk Length. Defaults to 6. passive_max_size Defaults to 30. passive_rwl Passive View Random Walk Length. Defaults to 6. random_promotion A boolean indicating if random promotion is enabled. Defaults true . random_promotion_interval Time after which the protocol attempts to promote a node in the passive view to the active view.Defaults to 5000. shuffle_interval Defaults to 10000. shuffle_k_active Number of peers to include in the shuffle exchange. Defaults to 3. shuffle_k_passive Number of peers to include in the shuffle exchange. Defaults to 4.","ref":"partisan_hyparview_peer_service_manager.html","title":"partisan_hyparview_peer_service_manager","type":"module"},{"doc":"Debugging.","ref":"partisan_hyparview_peer_service_manager.html#active/0","title":"partisan_hyparview_peer_service_manager.active/0","type":"function"},{"doc":"Debugging.","ref":"partisan_hyparview_peer_service_manager.html#active/1","title":"partisan_hyparview_peer_service_manager.active/1","type":"function"},{"doc":"Add to the active view. However, interesting race condition here: if the passive random walk timer exceeded and the node was added to the passive view, we might also have the active random walk timer exceed *after* because of a network delay; if so, we have to remove this element from the passive view, otherwise it will exist in both places.","ref":"partisan_hyparview_peer_service_manager.html#add_to_active_view/3","title":"partisan_hyparview_peer_service_manager.add_to_active_view/3","type":"function"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#cast_message/2","title":"partisan_hyparview_peer_service_manager.cast_message/2","type":"function"},{"doc":"Cast a message to a remote gen_server.","ref":"partisan_hyparview_peer_service_manager.html#cast_message/3","title":"partisan_hyparview_peer_service_manager.cast_message/3","type":"function"},{"doc":"Cast a message to a remote gen_server.","ref":"partisan_hyparview_peer_service_manager.html#cast_message/4","title":"partisan_hyparview_peer_service_manager.cast_message/4","type":"function"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#code_change/3","title":"partisan_hyparview_peer_service_manager.code_change/3","type":"function"},{"doc":"Decode state.","ref":"partisan_hyparview_peer_service_manager.html#decode/1","title":"partisan_hyparview_peer_service_manager.decode/1","type":"function"},{"doc":"Gensym support for forwarding.","ref":"partisan_hyparview_peer_service_manager.html#forward_message/2","title":"partisan_hyparview_peer_service_manager.forward_message/2","type":"function"},{"doc":"Gensym support for forwarding.","ref":"partisan_hyparview_peer_service_manager.html#forward_message/3","title":"partisan_hyparview_peer_service_manager.forward_message/3","type":"function"},{"doc":"Forward message to registered process on the remote side.","ref":"partisan_hyparview_peer_service_manager.html#forward_message/4","title":"partisan_hyparview_peer_service_manager.forward_message/4","type":"function"},{"doc":"Return local node's view of cluster membership.","ref":"partisan_hyparview_peer_service_manager.html#get_local_state/0","title":"partisan_hyparview_peer_service_manager.get_local_state/0","type":"function"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#handle_call/3","title":"partisan_hyparview_peer_service_manager.handle_call/3","type":"function"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#handle_cast/2","title":"partisan_hyparview_peer_service_manager.handle_cast/2","type":"function"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#handle_info/2","title":"partisan_hyparview_peer_service_manager.handle_info/2","type":"function"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#init/1","title":"partisan_hyparview_peer_service_manager.init/1","type":"function"},{"doc":"Inject a partition.","ref":"partisan_hyparview_peer_service_manager.html#inject_partition/2","title":"partisan_hyparview_peer_service_manager.inject_partition/2","type":"function"},{"doc":"Attempt to join a remote node.","ref":"partisan_hyparview_peer_service_manager.html#join/1","title":"partisan_hyparview_peer_service_manager.join/1","type":"function"},{"doc":"Leave the cluster.","ref":"partisan_hyparview_peer_service_manager.html#leave/0","title":"partisan_hyparview_peer_service_manager.leave/0","type":"function"},{"doc":"Remove another node from the cluster.","ref":"partisan_hyparview_peer_service_manager.html#leave/1","title":"partisan_hyparview_peer_service_manager.leave/1","type":"function"},{"doc":"Return membership list.","ref":"partisan_hyparview_peer_service_manager.html#members/0","title":"partisan_hyparview_peer_service_manager.members/0","type":"function"},{"doc":"Return membership list.","ref":"partisan_hyparview_peer_service_manager.html#members_for_orchestration/0","title":"partisan_hyparview_peer_service_manager.members_for_orchestration/0","type":"function"},{"doc":"Register a trigger to fire when a connection drops.","ref":"partisan_hyparview_peer_service_manager.html#on_down/2","title":"partisan_hyparview_peer_service_manager.on_down/2","type":"function"},{"doc":"Register a trigger to fire when a connection drops.","ref":"partisan_hyparview_peer_service_manager.html#on_down/3","title":"partisan_hyparview_peer_service_manager.on_down/3","type":"function"},{"doc":"Register a trigger to fire when a connection opens.","ref":"partisan_hyparview_peer_service_manager.html#on_up/2","title":"partisan_hyparview_peer_service_manager.on_up/2","type":"function"},{"doc":"Register a trigger to fire when a connection opens.","ref":"partisan_hyparview_peer_service_manager.html#on_up/3","title":"partisan_hyparview_peer_service_manager.on_up/3","type":"function"},{"doc":"Return partitions.","ref":"partisan_hyparview_peer_service_manager.html#partitions/0","title":"partisan_hyparview_peer_service_manager.partitions/0","type":"function"},{"doc":"Debugging.","ref":"partisan_hyparview_peer_service_manager.html#passive/0","title":"partisan_hyparview_peer_service_manager.passive/0","type":"function"},{"doc":"Receive message from a remote manager.","ref":"partisan_hyparview_peer_service_manager.html#receive_message/3","title":"partisan_hyparview_peer_service_manager.receive_message/3","type":"function"},{"doc":"Reserve a slot for the particular tag.","ref":"partisan_hyparview_peer_service_manager.html#reserve/1","title":"partisan_hyparview_peer_service_manager.reserve/1","type":"function"},{"doc":"Resolve a partition.","ref":"partisan_hyparview_peer_service_manager.html#resolve_partition/1","title":"partisan_hyparview_peer_service_manager.resolve_partition/1","type":"function"},{"doc":"Send message to a remote peer service manager.","ref":"partisan_hyparview_peer_service_manager.html#send_message/2","title":"partisan_hyparview_peer_service_manager.send_message/2","type":"function"},{"doc":"Start the peer service manager.","ref":"partisan_hyparview_peer_service_manager.html#start_link/0","title":"partisan_hyparview_peer_service_manager.start_link/0","type":"function"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#supports_capability/1","title":"partisan_hyparview_peer_service_manager.supports_capability/1","type":"function"},{"doc":"Attempt to join a remote node.","ref":"partisan_hyparview_peer_service_manager.html#sync_join/1","title":"partisan_hyparview_peer_service_manager.sync_join/1","type":"function"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#terminate/2","title":"partisan_hyparview_peer_service_manager.terminate/2","type":"function"},{"doc":"Update membership.","ref":"partisan_hyparview_peer_service_manager.html#update_members/1","title":"partisan_hyparview_peer_service_manager.update_members/1","type":"function"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:active/0","title":"partisan_hyparview_peer_service_manager.active/0","type":"type"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:call/0","title":"partisan_hyparview_peer_service_manager.call/0","type":"type"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:cast/0","title":"partisan_hyparview_peer_service_manager.cast/0","type":"type"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:config/0","title":"partisan_hyparview_peer_service_manager.config/0","type":"type"},{"doc":"The epoch_count indicates how many disconnect messages are generated.","ref":"partisan_hyparview_peer_service_manager.html#t:epoch/0","title":"partisan_hyparview_peer_service_manager.epoch/0","type":"type"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:epoch_count/0","title":"partisan_hyparview_peer_service_manager.epoch_count/0","type":"type"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:message_id/0","title":"partisan_hyparview_peer_service_manager.message_id/0","type":"type"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:message_id_store/0","title":"partisan_hyparview_peer_service_manager.message_id_store/0","type":"type"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:passive/0","title":"partisan_hyparview_peer_service_manager.passive/0","type":"type"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:reserved/0","title":"partisan_hyparview_peer_service_manager.reserved/0","type":"type"},{"doc":"","ref":"partisan_hyparview_peer_service_manager.html#t:t/0","title":"partisan_hyparview_peer_service_manager.t/0","type":"type"},{"doc":"The epoch indicates how many times the node is restarted.","ref":"partisan_hyparview_peer_service_manager.html#t:tag/0","title":"partisan_hyparview_peer_service_manager.tag/0","type":"type"},{"doc":"This module realises the partisan_peer_service_manager behaviour implementing a full-mesh topology. Characteristics Uses TCP/IP. All nodes communicate and maintain connections with all other nodes. Nodes periodically send heartbeat messages. The service considers a node &quot;failed&quot; when it misses X heartbeats. Point-to-point messaging with a single network hop. Eventually consistent membership maintained in a CRDT and replicated using gossip. Scalability limited to hundres of nodes (60-200 nodes).","ref":"partisan_pluggable_peer_service_manager.html","title":"partisan_pluggable_peer_service_manager","type":"module"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#add_interposition_fun/2","title":"partisan_pluggable_peer_service_manager.add_interposition_fun/2","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#add_post_interposition_fun/2","title":"partisan_pluggable_peer_service_manager.add_post_interposition_fun/2","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#add_pre_interposition_fun/2","title":"partisan_pluggable_peer_service_manager.add_pre_interposition_fun/2","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#cast_message/2","title":"partisan_pluggable_peer_service_manager.cast_message/2","type":"function"},{"doc":"Cast a message to a remote gen_server.","ref":"partisan_pluggable_peer_service_manager.html#cast_message/3","title":"partisan_pluggable_peer_service_manager.cast_message/3","type":"function"},{"doc":"Cast a message to a remote gen_server.","ref":"partisan_pluggable_peer_service_manager.html#cast_message/4","title":"partisan_pluggable_peer_service_manager.cast_message/4","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#code_change/3","title":"partisan_pluggable_peer_service_manager.code_change/3","type":"function"},{"doc":"Decode state.","ref":"partisan_pluggable_peer_service_manager.html#decode/1","title":"partisan_pluggable_peer_service_manager.decode/1","type":"function"},{"doc":"Gensym support for forwarding.","ref":"partisan_pluggable_peer_service_manager.html#forward_message/2","title":"partisan_pluggable_peer_service_manager.forward_message/2","type":"function"},{"doc":"Gensym support for forwarding.","ref":"partisan_pluggable_peer_service_manager.html#forward_message/3","title":"partisan_pluggable_peer_service_manager.forward_message/3","type":"function"},{"doc":"Forward message to registered process on the remote side.","ref":"partisan_pluggable_peer_service_manager.html#forward_message/4","title":"partisan_pluggable_peer_service_manager.forward_message/4","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#get_interposition_funs/0","title":"partisan_pluggable_peer_service_manager.get_interposition_funs/0","type":"function"},{"doc":"Return local node's view of cluster membership.","ref":"partisan_pluggable_peer_service_manager.html#get_local_state/0","title":"partisan_pluggable_peer_service_manager.get_local_state/0","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#get_pre_interposition_funs/0","title":"partisan_pluggable_peer_service_manager.get_pre_interposition_funs/0","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#handle_call/3","title":"partisan_pluggable_peer_service_manager.handle_call/3","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#handle_cast/2","title":"partisan_pluggable_peer_service_manager.handle_cast/2","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#handle_info/2","title":"partisan_pluggable_peer_service_manager.handle_info/2","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#init/1","title":"partisan_pluggable_peer_service_manager.init/1","type":"function"},{"doc":"Inject a partition.","ref":"partisan_pluggable_peer_service_manager.html#inject_partition/2","title":"partisan_pluggable_peer_service_manager.inject_partition/2","type":"function"},{"doc":"Attempt to join a remote node.","ref":"partisan_pluggable_peer_service_manager.html#join/1","title":"partisan_pluggable_peer_service_manager.join/1","type":"function"},{"doc":"Leave the cluster.","ref":"partisan_pluggable_peer_service_manager.html#leave/0","title":"partisan_pluggable_peer_service_manager.leave/0","type":"function"},{"doc":"Remove another node from the cluster.","ref":"partisan_pluggable_peer_service_manager.html#leave/1","title":"partisan_pluggable_peer_service_manager.leave/1","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#maybe_reply_sync_joins/1","title":"partisan_pluggable_peer_service_manager.maybe_reply_sync_joins/1","type":"function"},{"doc":"Returns true if node Node is a member in the membership list. Otherwise returns false .","ref":"partisan_pluggable_peer_service_manager.html#member/1","title":"partisan_pluggable_peer_service_manager.member/1","type":"function"},{"doc":"Return membership list.","ref":"partisan_pluggable_peer_service_manager.html#members/0","title":"partisan_pluggable_peer_service_manager.members/0","type":"function"},{"doc":"Return membership list.","ref":"partisan_pluggable_peer_service_manager.html#members_for_orchestration/0","title":"partisan_pluggable_peer_service_manager.members_for_orchestration/0","type":"function"},{"doc":"Trigger function on connection close for a given node. Fun is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_pluggable_peer_service_manager.html#on_down/2","title":"partisan_pluggable_peer_service_manager.on_down/2","type":"function"},{"doc":"Trigger function on connection close for a given node. Fun is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_pluggable_peer_service_manager.html#on_down/3","title":"partisan_pluggable_peer_service_manager.on_down/3","type":"function"},{"doc":"Trigger function on connection open for a given node. Fun is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_pluggable_peer_service_manager.html#on_up/2","title":"partisan_pluggable_peer_service_manager.on_up/2","type":"function"},{"doc":"Trigger function on connection open for a given node. Fun is a function object taking zero or a single argument, where the argument is the Node name.","ref":"partisan_pluggable_peer_service_manager.html#on_up/3","title":"partisan_pluggable_peer_service_manager.on_up/3","type":"function"},{"doc":"Return partitions.","ref":"partisan_pluggable_peer_service_manager.html#partitions/0","title":"partisan_pluggable_peer_service_manager.partitions/0","type":"function"},{"doc":"Receive message from a remote manager.","ref":"partisan_pluggable_peer_service_manager.html#receive_message/3","title":"partisan_pluggable_peer_service_manager.receive_message/3","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#remove_interposition_fun/1","title":"partisan_pluggable_peer_service_manager.remove_interposition_fun/1","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#remove_post_interposition_fun/1","title":"partisan_pluggable_peer_service_manager.remove_post_interposition_fun/1","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#remove_pre_interposition_fun/1","title":"partisan_pluggable_peer_service_manager.remove_pre_interposition_fun/1","type":"function"},{"doc":"Reserve a slot for the particular tag.","ref":"partisan_pluggable_peer_service_manager.html#reserve/1","title":"partisan_pluggable_peer_service_manager.reserve/1","type":"function"},{"doc":"Resolve a partition.","ref":"partisan_pluggable_peer_service_manager.html#resolve_partition/1","title":"partisan_pluggable_peer_service_manager.resolve_partition/1","type":"function"},{"doc":"Send message to a remote peer service manager.","ref":"partisan_pluggable_peer_service_manager.html#send_message/2","title":"partisan_pluggable_peer_service_manager.send_message/2","type":"function"},{"doc":"Same as start_link([]).","ref":"partisan_pluggable_peer_service_manager.html#start_link/0","title":"partisan_pluggable_peer_service_manager.start_link/0","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#supports_capability/1","title":"partisan_pluggable_peer_service_manager.supports_capability/1","type":"function"},{"doc":"Attempt to join a remote node.","ref":"partisan_pluggable_peer_service_manager.html#sync_join/1","title":"partisan_pluggable_peer_service_manager.sync_join/1","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#terminate/2","title":"partisan_pluggable_peer_service_manager.terminate/2","type":"function"},{"doc":"Update membership.","ref":"partisan_pluggable_peer_service_manager.html#update_members/1","title":"partisan_pluggable_peer_service_manager.update_members/1","type":"function"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:channel_subs/0","title":"partisan_pluggable_peer_service_manager.channel_subs/0","type":"type"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:from/0","title":"partisan_pluggable_peer_service_manager.from/0","type":"type"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:info/0","title":"partisan_pluggable_peer_service_manager.info/0","type":"type"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:interpos_arg/0","title":"partisan_pluggable_peer_service_manager.interpos_arg/0","type":"type"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:interpos_fun/0","title":"partisan_pluggable_peer_service_manager.interpos_fun/0","type":"type"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:interposition_map/1","title":"partisan_pluggable_peer_service_manager.interposition_map/1","type":"type"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:node_subs/0","title":"partisan_pluggable_peer_service_manager.node_subs/0","type":"type"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:on_event_fun/0","title":"partisan_pluggable_peer_service_manager.on_event_fun/0","type":"type"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:t/0","title":"partisan_pluggable_peer_service_manager.t/0","type":"type"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:tag/0","title":"partisan_pluggable_peer_service_manager.tag/0","type":"type"},{"doc":"","ref":"partisan_pluggable_peer_service_manager.html#t:x_interpos_fun/0","title":"partisan_pluggable_peer_service_manager.x_interpos_fun/0","type":"type"},{"doc":"","ref":"partisan_static_peer_service_manager.html","title":"partisan_static_peer_service_manager","type":"module"},{"doc":"","ref":"partisan_static_peer_service_manager.html#cast_message/2","title":"partisan_static_peer_service_manager.cast_message/2","type":"function"},{"doc":"Cast a message to a remote gen_server.","ref":"partisan_static_peer_service_manager.html#cast_message/3","title":"partisan_static_peer_service_manager.cast_message/3","type":"function"},{"doc":"Cast a message to a remote gen_server.","ref":"partisan_static_peer_service_manager.html#cast_message/4","title":"partisan_static_peer_service_manager.cast_message/4","type":"function"},{"doc":"Decode state.","ref":"partisan_static_peer_service_manager.html#decode/1","title":"partisan_static_peer_service_manager.decode/1","type":"function"},{"doc":"Gensym support for forwarding.","ref":"partisan_static_peer_service_manager.html#forward_message/2","title":"partisan_static_peer_service_manager.forward_message/2","type":"function"},{"doc":"Gensym support for forwarding.","ref":"partisan_static_peer_service_manager.html#forward_message/3","title":"partisan_static_peer_service_manager.forward_message/3","type":"function"},{"doc":"Forward message to registered process on the remote side.","ref":"partisan_static_peer_service_manager.html#forward_message/4","title":"partisan_static_peer_service_manager.forward_message/4","type":"function"},{"doc":"Return local node's view of cluster membership.","ref":"partisan_static_peer_service_manager.html#get_local_state/0","title":"partisan_static_peer_service_manager.get_local_state/0","type":"function"},{"doc":"","ref":"partisan_static_peer_service_manager.html#handle_info/2","title":"partisan_static_peer_service_manager.handle_info/2","type":"function"},{"doc":"","ref":"partisan_static_peer_service_manager.html#handle_message/3","title":"partisan_static_peer_service_manager.handle_message/3","type":"function"},{"doc":"Inject a partition.","ref":"partisan_static_peer_service_manager.html#inject_partition/2","title":"partisan_static_peer_service_manager.inject_partition/2","type":"function"},{"doc":"Attempt to join a remote node.","ref":"partisan_static_peer_service_manager.html#join/1","title":"partisan_static_peer_service_manager.join/1","type":"function"},{"doc":"Leave the cluster.","ref":"partisan_static_peer_service_manager.html#leave/0","title":"partisan_static_peer_service_manager.leave/0","type":"function"},{"doc":"Remove another node from the cluster.","ref":"partisan_static_peer_service_manager.html#leave/1","title":"partisan_static_peer_service_manager.leave/1","type":"function"},{"doc":"Return membership list.","ref":"partisan_static_peer_service_manager.html#members/0","title":"partisan_static_peer_service_manager.members/0","type":"function"},{"doc":"Return membership list.","ref":"partisan_static_peer_service_manager.html#members_for_orchestration/0","title":"partisan_static_peer_service_manager.members_for_orchestration/0","type":"function"},{"doc":"Trigger function on connection close for a given node.","ref":"partisan_static_peer_service_manager.html#on_down/2","title":"partisan_static_peer_service_manager.on_down/2","type":"function"},{"doc":"Trigger function on connection open for a given node.","ref":"partisan_static_peer_service_manager.html#on_up/2","title":"partisan_static_peer_service_manager.on_up/2","type":"function"},{"doc":"Return partitions.","ref":"partisan_static_peer_service_manager.html#partitions/0","title":"partisan_static_peer_service_manager.partitions/0","type":"function"},{"doc":"Receive message from a remote manager.","ref":"partisan_static_peer_service_manager.html#receive_message/3","title":"partisan_static_peer_service_manager.receive_message/3","type":"function"},{"doc":"Reserve a slot for the particular tag.","ref":"partisan_static_peer_service_manager.html#reserve/1","title":"partisan_static_peer_service_manager.reserve/1","type":"function"},{"doc":"Resolve a partition.","ref":"partisan_static_peer_service_manager.html#resolve_partition/1","title":"partisan_static_peer_service_manager.resolve_partition/1","type":"function"},{"doc":"Send message to a remote manager.","ref":"partisan_static_peer_service_manager.html#send_message/2","title":"partisan_static_peer_service_manager.send_message/2","type":"function"},{"doc":"Same as start_link([]).","ref":"partisan_static_peer_service_manager.html#start_link/0","title":"partisan_static_peer_service_manager.start_link/0","type":"function"},{"doc":"","ref":"partisan_static_peer_service_manager.html#supports_capability/1","title":"partisan_static_peer_service_manager.supports_capability/1","type":"function"},{"doc":"Attempt to join a remote node.","ref":"partisan_static_peer_service_manager.html#sync_join/1","title":"partisan_static_peer_service_manager.sync_join/1","type":"function"},{"doc":"Update membership.","ref":"partisan_static_peer_service_manager.html#update_members/1","title":"partisan_static_peer_service_manager.update_members/1","type":"function"},{"doc":"","ref":"partisan_static_peer_service_manager.html#t:membership/0","title":"partisan_static_peer_service_manager.membership/0","type":"type"},{"doc":"","ref":"partisan_static_peer_service_manager.html#t:pending/0","title":"partisan_static_peer_service_manager.pending/0","type":"type"},{"doc":"","ref":"partisan_static_peer_service_manager.html#t:state_t/0","title":"partisan_static_peer_service_manager.state_t/0","type":"type"},{"doc":"This module implements the full-mesh membership strategy to be used with {link partisan_pluggable_peer_service_manager}.","ref":"partisan_full_membership_strategy.html","title":"partisan_full_membership_strategy","type":"module"},{"doc":"Returns the tuple {Joiners, Leavers} where Joiners is the list of node specifications that are elements of List but are not in the membership set, and Leavers are the node specifications for the current members that are not elements in List .","ref":"partisan_full_membership_strategy.html#compare/2","title":"partisan_full_membership_strategy.compare/2","type":"function"},{"doc":"Handling incoming protocol message.","ref":"partisan_full_membership_strategy.html#handle_message/2","title":"partisan_full_membership_strategy.handle_message/2","type":"function"},{"doc":"Initialize the strategy state.","ref":"partisan_full_membership_strategy.html#init/1","title":"partisan_full_membership_strategy.init/1","type":"function"},{"doc":"When a node is connected, return the state, membership and outgoing message queue to be transmitted.","ref":"partisan_full_membership_strategy.html#join/3","title":"partisan_full_membership_strategy.join/3","type":"function"},{"doc":"Leave a node from the cluster.","ref":"partisan_full_membership_strategy.html#leave/2","title":"partisan_full_membership_strategy.leave/2","type":"function"},{"doc":"Periodic protocol maintenance.","ref":"partisan_full_membership_strategy.html#periodic/1","title":"partisan_full_membership_strategy.periodic/1","type":"function"},{"doc":"","ref":"partisan_full_membership_strategy.html#prune/2","title":"partisan_full_membership_strategy.prune/2","type":"function"},{"doc":"","ref":"partisan_full_membership_strategy.html#t:membership_list/0","title":"partisan_full_membership_strategy.membership_list/0","type":"type"},{"doc":"","ref":"partisan_full_membership_strategy.html#t:outgoing_messages/0","title":"partisan_full_membership_strategy.outgoing_messages/0","type":"type"},{"doc":"","ref":"partisan_full_membership_strategy.html#t:t/0","title":"partisan_full_membership_strategy.t/0","type":"type"},{"doc":"This module represents the cluster membership view for this node. When a node joins the cluster it is added to the set. Conversely when a node leaves the cluster it is removed from the set. A node that crashes or gets disconnected will remain in the set so that Partisan can try to re-connect with the node when it restarts or becomes reachable again. Implementation The set is implemented as a CRDT set of partisan:node_spec/0 objects. More specifically a state_orset. Notice that because the set stores partisan:node_spec/0 objects and not node() , the set can have multiple partisan:node_spec/0 objects for the same node. This can occur when the set contains one or more stale specifications . Stale Specifications A stale specification exists due to the following reasons: A node crashes (without leaving the cluster) and returns bearing different IP Addresses (the value of the node specification's listen_addrs property). This is common in cloud orchestration scenarios where instances have dynamic IP addresses. A node crashes (without leaving the cluster) and returns bearing different values for the node specification properties channels and/or parallelism . For example, this can happen in the case the Partisan configuration has changed when using a rolling update strategy i.e. a gradual update process that allows you to update a cluster one node at a time to minimise downtime.","ref":"partisan_membership_set.html","title":"partisan_membership_set","type":"module"},{"doc":"","ref":"partisan_membership_set.html#add/3","title":"partisan_membership_set.add/3","type":"function"},{"doc":"Returns the tuple {Joiners, Leavers} where Joiners is the list of node specifications that are elements of List but are not in the membership set, and Leavers are the node specifications for the current members that are not elements in List .","ref":"partisan_membership_set.html#compare/2","title":"partisan_membership_set.compare/2","type":"function"},{"doc":"","ref":"partisan_membership_set.html#decode/1","title":"partisan_membership_set.decode/1","type":"function"},{"doc":"","ref":"partisan_membership_set.html#encode/1","title":"partisan_membership_set.encode/1","type":"function"},{"doc":"","ref":"partisan_membership_set.html#equal/2","title":"partisan_membership_set.equal/2","type":"function"},{"doc":"","ref":"partisan_membership_set.html#merge/2","title":"partisan_membership_set.merge/2","type":"function"},{"doc":"","ref":"partisan_membership_set.html#new/0","title":"partisan_membership_set.new/0","type":"function"},{"doc":"","ref":"partisan_membership_set.html#remove/3","title":"partisan_membership_set.remove/3","type":"function"},{"doc":"","ref":"partisan_membership_set.html#to_list/1","title":"partisan_membership_set.to_list/1","type":"function"},{"doc":"Returns a list of node specifications but omitting the specification for the local node. No sorting is applied, so the sorting is undefined.","ref":"partisan_membership_set.html#to_peer_list/1","title":"partisan_membership_set.to_peer_list/1","type":"function"},{"doc":"","ref":"partisan_membership_set.html#t:t/0","title":"partisan_membership_set.t/0","type":"opaque"},{"doc":"","ref":"partisan_membership_strategy.html","title":"partisan_membership_strategy","type":"behaviour"},{"doc":"","ref":"partisan_membership_strategy.html#c:compare/2","title":"partisan_membership_strategy.compare/2","type":"callback"},{"doc":"","ref":"partisan_membership_strategy.html#c:handle_message/2","title":"partisan_membership_strategy.handle_message/2","type":"callback"},{"doc":"","ref":"partisan_membership_strategy.html#handle_message/3","title":"partisan_membership_strategy.handle_message/3","type":"function"},{"doc":"","ref":"partisan_membership_strategy.html#c:init/1","title":"partisan_membership_strategy.init/1","type":"callback"},{"doc":"","ref":"partisan_membership_strategy.html#init/2","title":"partisan_membership_strategy.init/2","type":"function"},{"doc":"","ref":"partisan_membership_strategy.html#c:join/3","title":"partisan_membership_strategy.join/3","type":"callback"},{"doc":"","ref":"partisan_membership_strategy.html#join/4","title":"partisan_membership_strategy.join/4","type":"function"},{"doc":"","ref":"partisan_membership_strategy.html#c:leave/2","title":"partisan_membership_strategy.leave/2","type":"callback"},{"doc":"","ref":"partisan_membership_strategy.html#leave/3","title":"partisan_membership_strategy.leave/3","type":"function"},{"doc":"","ref":"partisan_membership_strategy.html#c:periodic/1","title":"partisan_membership_strategy.periodic/1","type":"callback"},{"doc":"","ref":"partisan_membership_strategy.html#periodic/2","title":"partisan_membership_strategy.periodic/2","type":"function"},{"doc":"","ref":"partisan_membership_strategy.html#c:prune/2","title":"partisan_membership_strategy.prune/2","type":"callback"},{"doc":"","ref":"partisan_membership_strategy.html#prune/3","title":"partisan_membership_strategy.prune/3","type":"function"},{"doc":"","ref":"partisan_membership_strategy.html#t:membership_list/0","title":"partisan_membership_strategy.membership_list/0","type":"type"},{"doc":"","ref":"partisan_membership_strategy.html#t:outgoing_message/0","title":"partisan_membership_strategy.outgoing_message/0","type":"type"},{"doc":"","ref":"partisan_membership_strategy.html#t:outgoing_messages/0","title":"partisan_membership_strategy.outgoing_messages/0","type":"type"},{"doc":"","ref":"partisan_scamp_v1_membership_strategy.html","title":"partisan_scamp_v1_membership_strategy","type":"module"},{"doc":"Returns the tuple {Joiners, Leavers} where Joiners is the list of node specifications that are elements of List but are not in the membership set, and Leavers are the node specifications for the current members that are not elements in List .","ref":"partisan_scamp_v1_membership_strategy.html#compare/2","title":"partisan_scamp_v1_membership_strategy.compare/2","type":"function"},{"doc":"Handling incoming protocol message.","ref":"partisan_scamp_v1_membership_strategy.html#handle_message/2","title":"partisan_scamp_v1_membership_strategy.handle_message/2","type":"function"},{"doc":"Initialize the strategy state. Start with an empty state with only ourselves known.","ref":"partisan_scamp_v1_membership_strategy.html#init/1","title":"partisan_scamp_v1_membership_strategy.init/1","type":"function"},{"doc":"When a remote node is connected, notify that node to add us. Then, perform forwarding, if necessary.","ref":"partisan_scamp_v1_membership_strategy.html#join/3","title":"partisan_scamp_v1_membership_strategy.join/3","type":"function"},{"doc":"Leave a node from the cluster.","ref":"partisan_scamp_v1_membership_strategy.html#leave/2","title":"partisan_scamp_v1_membership_strategy.leave/2","type":"function"},{"doc":"Periodic protocol maintenance.","ref":"partisan_scamp_v1_membership_strategy.html#periodic/1","title":"partisan_scamp_v1_membership_strategy.periodic/1","type":"function"},{"doc":"","ref":"partisan_scamp_v1_membership_strategy.html#prune/2","title":"partisan_scamp_v1_membership_strategy.prune/2","type":"function"},{"doc":"http://stackoverflow.com/questions/8817171/shuffling-elements-in-a-list-randomly-re-arrange-list-elements/8820501#8820501","ref":"partisan_scamp_v1_membership_strategy.html#shuffle/1","title":"partisan_scamp_v1_membership_strategy.shuffle/1","type":"function"},{"doc":"","ref":"partisan_scamp_v1_membership_strategy.html#t:t/0","title":"partisan_scamp_v1_membership_strategy.t/0","type":"type"},{"doc":"","ref":"partisan_scamp_v2_membership_strategy.html","title":"partisan_scamp_v2_membership_strategy","type":"module"},{"doc":"Returns the tuple {Joiners, Leavers} where Joiners is the list of node specifications that are elements of List but are not in the membership set, and Leavers are the node specifications for the current members that are not elements in List .","ref":"partisan_scamp_v2_membership_strategy.html#compare/2","title":"partisan_scamp_v2_membership_strategy.compare/2","type":"function"},{"doc":"Handling incoming protocol message.","ref":"partisan_scamp_v2_membership_strategy.html#handle_message/2","title":"partisan_scamp_v2_membership_strategy.handle_message/2","type":"function"},{"doc":"Initialize the strategy state. Start with an empty state with only ourselves known.","ref":"partisan_scamp_v2_membership_strategy.html#init/1","title":"partisan_scamp_v2_membership_strategy.init/1","type":"function"},{"doc":"When a remote node is connected, notify that node to add us. Then, perform forwarding, if necessary.","ref":"partisan_scamp_v2_membership_strategy.html#join/3","title":"partisan_scamp_v2_membership_strategy.join/3","type":"function"},{"doc":"Leave a node from the cluster.","ref":"partisan_scamp_v2_membership_strategy.html#leave/2","title":"partisan_scamp_v2_membership_strategy.leave/2","type":"function"},{"doc":"Periodic protocol maintenance.","ref":"partisan_scamp_v2_membership_strategy.html#periodic/1","title":"partisan_scamp_v2_membership_strategy.periodic/1","type":"function"},{"doc":"","ref":"partisan_scamp_v2_membership_strategy.html#prune/2","title":"partisan_scamp_v2_membership_strategy.prune/2","type":"function"},{"doc":"","ref":"partisan_scamp_v2_membership_strategy.html#t:t/0","title":"partisan_scamp_v2_membership_strategy.t/0","type":"type"},{"doc":"This modules implements a server that realises the partisan_plumtree_broadcast_handler behaviour in order to diseminate heartbeat messages. Partisan uses these heartbeat messages to stimulate the Epidemic Broadcast Tree construction. The server will schedule the sending of a hearbeat` message periodically using the `broadcast_heartbeat_interval` option. Notice that this handler does not perform AAE Exchanges, as we will always have a periodic heartbeat. For that reason, the implementation of the &lt;a docgen-rel=&quot;seemfa&quot; docgen-href=&quot;partisan_plumtree_broadcast_handler#exchange/1&quot; href=&quot;partisan_plumtree_broadcast_handler.html#exchange-1&quot;&gt;&lt;code&gt;partisan_plumtree_broadcast_handler:exchange/1&lt;/code&gt;&lt;/a&gt; callback always returns `ignore .","ref":"partisan_plumtree_backend.html","title":"partisan_plumtree_backend","type":"module"},{"doc":"Returns the channel to be used when broadcasting a message on behalf of this handler.","ref":"partisan_plumtree_backend.html#broadcast_channel/0","title":"partisan_plumtree_backend.broadcast_channel/0","type":"function"},{"doc":"Returns from the broadcast message the identifier and the payload. In this case a tuple where both arguments have the broadcast message timestamp . These messages are used by Partisan as a stimulus for the Epidemic Broadcast Tree (Plumtree) construction.","ref":"partisan_plumtree_backend.html#broadcast_data/1","title":"partisan_plumtree_backend.broadcast_data/1","type":"function"},{"doc":"","ref":"partisan_plumtree_backend.html#code_change/3","title":"partisan_plumtree_backend.code_change/3","type":"function"},{"doc":"Returns ignore`. This is because we don t need to worry about reliable delivery: we always know we'll have another heartbeat message to further repair during the next interval.","ref":"partisan_plumtree_backend.html#exchange/1","title":"partisan_plumtree_backend.exchange/1","type":"function"},{"doc":"","ref":"partisan_plumtree_backend.html#extract_log_type_and_payload/1","title":"partisan_plumtree_backend.extract_log_type_and_payload/1","type":"function"},{"doc":"Given a message identifier and a clock, return a given message.","ref":"partisan_plumtree_backend.html#graft/1","title":"partisan_plumtree_backend.graft/1","type":"function"},{"doc":"","ref":"partisan_plumtree_backend.html#handle_call/3","title":"partisan_plumtree_backend.handle_call/3","type":"function"},{"doc":"","ref":"partisan_plumtree_backend.html#handle_cast/2","title":"partisan_plumtree_backend.handle_cast/2","type":"function"},{"doc":"","ref":"partisan_plumtree_backend.html#handle_info/2","title":"partisan_plumtree_backend.handle_info/2","type":"function"},{"doc":"","ref":"partisan_plumtree_backend.html#init/1","title":"partisan_plumtree_backend.init/1","type":"function"},{"doc":"Use the clock on the object to determine if this message is stale or not.","ref":"partisan_plumtree_backend.html#is_stale/1","title":"partisan_plumtree_backend.is_stale/1","type":"function"},{"doc":"Perform a merge of an incoming object with an object in the local datastore.","ref":"partisan_plumtree_backend.html#merge/2","title":"partisan_plumtree_backend.merge/2","type":"function"},{"doc":"Same as start_link([]).","ref":"partisan_plumtree_backend.html#start_link/0","title":"partisan_plumtree_backend.start_link/0","type":"function"},{"doc":"Start and link to calling process.","ref":"partisan_plumtree_backend.html#start_link/1","title":"partisan_plumtree_backend.start_link/1","type":"function"},{"doc":"","ref":"partisan_plumtree_backend.html#terminate/2","title":"partisan_plumtree_backend.terminate/2","type":"function"},{"doc":"","ref":"partisan_plumtree_backend.html#t:broadcast_id/0","title":"partisan_plumtree_backend.broadcast_id/0","type":"type"},{"doc":"","ref":"partisan_plumtree_backend.html#t:broadcast_message/0","title":"partisan_plumtree_backend.broadcast_message/0","type":"type"},{"doc":"","ref":"partisan_plumtree_backend.html#t:broadcast_payload/0","title":"partisan_plumtree_backend.broadcast_payload/0","type":"type"},{"doc":"","ref":"partisan_plumtree_backend.html#t:state/0","title":"partisan_plumtree_backend.state/0","type":"type"},{"doc":"","ref":"partisan_plumtree_backend.html#t:timestamp/0","title":"partisan_plumtree_backend.timestamp/0","type":"type"},{"doc":"","ref":"partisan_plumtree_broadcast.html","title":"partisan_plumtree_broadcast","type":"module"},{"doc":"Broadcasts a message originating from this node. The message will be delivered to each node at least once. The Mod passed must be loaded on all members of the cluster and implement the partisan_plumtree_broadcast_handler behaviour which is responsible for handling the message on remote nodes as well as providing some other information both locally and on other nodes. The broadcast will be sent over the channel defined by broadcast_channel/1 .","ref":"partisan_plumtree_broadcast.html#broadcast/2","title":"partisan_plumtree_broadcast.broadcast/2","type":"function"},{"doc":"Returns the channel to be used when sending broadcasting a message on behalf of module Mod . The channel defined by the callback Mod:broadcast_channel() or default channel i.e. partisan:default_channel/0 if the callback is not implemented.","ref":"partisan_plumtree_broadcast.html#broadcast_channel/1","title":"partisan_plumtree_broadcast.broadcast_channel/1","type":"function"},{"doc":"Returns the broadcast servers view of full cluster membership. Wait indefinitely for a response is returned from the process.","ref":"partisan_plumtree_broadcast.html#broadcast_members/0","title":"partisan_plumtree_broadcast.broadcast_members/0","type":"function"},{"doc":"Returns the broadcast servers view of full cluster membership. Waits Timeout ms for a response from the server.","ref":"partisan_plumtree_broadcast.html#broadcast_members/1","title":"partisan_plumtree_broadcast.broadcast_members/1","type":"function"},{"doc":"Cancel exchanges started by this node.","ref":"partisan_plumtree_broadcast.html#cancel_exchanges/1","title":"partisan_plumtree_broadcast.cancel_exchanges/1","type":"function"},{"doc":"","ref":"partisan_plumtree_broadcast.html#code_change/3","title":"partisan_plumtree_broadcast.code_change/3","type":"function"},{"doc":"return the peers for Node for the tree rooted at Root . Wait indefinitely for a response is returned from the process","ref":"partisan_plumtree_broadcast.html#debug_get_peers/2","title":"partisan_plumtree_broadcast.debug_get_peers/2","type":"function"},{"doc":"return the peers for Node for the tree rooted at Root . Waits Timeout ms for a response from the server","ref":"partisan_plumtree_broadcast.html#debug_get_peers/3","title":"partisan_plumtree_broadcast.debug_get_peers/3","type":"function"},{"doc":"return peers for all Nodes for tree rooted at Root Wait indefinitely for a response is returned from the process","ref":"partisan_plumtree_broadcast.html#debug_get_tree/2","title":"partisan_plumtree_broadcast.debug_get_tree/2","type":"function"},{"doc":"return peers for all Nodes for tree rooted at Root Wait indefinitely for a response is returned from the process","ref":"partisan_plumtree_broadcast.html#debug_get_tree/3","title":"partisan_plumtree_broadcast.debug_get_tree/3","type":"function"},{"doc":"return a list of exchanges, started by broadcast on this node, that are running.","ref":"partisan_plumtree_broadcast.html#exchanges/0","title":"partisan_plumtree_broadcast.exchanges/0","type":"function"},{"doc":"Returns a list of running exchanges, started on Node .","ref":"partisan_plumtree_broadcast.html#exchanges/1","title":"partisan_plumtree_broadcast.exchanges/1","type":"function"},{"doc":"Returns a list of running exchanges, started on Node .","ref":"partisan_plumtree_broadcast.html#exchanges/2","title":"partisan_plumtree_broadcast.exchanges/2","type":"function"},{"doc":"","ref":"partisan_plumtree_broadcast.html#get_eager_peers/1","title":"partisan_plumtree_broadcast.get_eager_peers/1","type":"function"},{"doc":"","ref":"partisan_plumtree_broadcast.html#get_lazy_peers/1","title":"partisan_plumtree_broadcast.get_lazy_peers/1","type":"function"},{"doc":"","ref":"partisan_plumtree_broadcast.html#get_peers/1","title":"partisan_plumtree_broadcast.get_peers/1","type":"function"},{"doc":"","ref":"partisan_plumtree_broadcast.html#handle_call/3","title":"partisan_plumtree_broadcast.handle_call/3","type":"function"},{"doc":"","ref":"partisan_plumtree_broadcast.html#handle_cast/2","title":"partisan_plumtree_broadcast.handle_cast/2","type":"function"},{"doc":"","ref":"partisan_plumtree_broadcast.html#handle_info/2","title":"partisan_plumtree_broadcast.handle_info/2","type":"function"},{"doc":"","ref":"partisan_plumtree_broadcast.html#init/1","title":"partisan_plumtree_broadcast.init/1","type":"function"},{"doc":"","ref":"partisan_plumtree_broadcast.html#maybe_exchange/2","title":"partisan_plumtree_broadcast.maybe_exchange/2","type":"function"},{"doc":"picks random peer favoring peers not in eager or lazy set and ensuring peer is not this node","ref":"partisan_plumtree_broadcast.html#random_peer/2","title":"partisan_plumtree_broadcast.random_peer/2","type":"function"},{"doc":"Starts the broadcast server on this node. The initial membership list is fetched from the configured {link partisan_peer_service}. If the node is a singleton then the initial eager and lazy sets are empty. If there are two nodes, each will be in the others eager set and the lazy sets will be empty. When number of members is less than 5, each node will initially have one other node in its eager set and lazy set. If there are more than five nodes each node will have at most two other nodes in its eager set and one in its lazy set, initially. In addition, after the broadcast server is started, all callbacks defined in the configuration option broadcast_mods are registered. By default the list of callbacks includes the module partisan_plumtree_backend which is used by to generate membership updates as the ring changes.","ref":"partisan_plumtree_broadcast.html#start_link/0","title":"partisan_plumtree_broadcast.start_link/0","type":"function"},{"doc":"Starts the broadcast server on this node. Members must be a list of all members known to this node when starting the broadcast server. Eagers are the initial peers of this node for all broadcast trees. Lazys is a list of random peers not in Eagers that will be used as the initial lazy peer shared by all trees for this node. If the number of nodes in the cluster is less than 3, Lazys should be an empty list. Eagers and Lazys must also be subsets of Members . Mods is a list of modules that may be handlers for broadcasted messages. All modules in Mods should implement the partisan_plumtree_broadcast_handler behaviour. Opts is a proplist or map with the following possible options: lazy_tick_period :: non_neg_integer() - Flush all outstanding lazy pushes period (in milliseconds) exchange_tick_period :: non_neg_integer() - Possibly perform an exchange period (in milliseconds) NOTE: When starting the server using start_link/2 no automatic membership update from ring_events is registered. Use start_link/0 .","ref":"partisan_plumtree_broadcast.html#start_link/5","title":"partisan_plumtree_broadcast.start_link/5","type":"function"},{"doc":"","ref":"partisan_plumtree_broadcast.html#terminate/2","title":"partisan_plumtree_broadcast.terminate/2","type":"function"},{"doc":"Notifies broadcast server of membership update This is the function is added to partisan_peer_service_events using partisan_peer_service:add_sup_callback(fun ?MODULE:update/1),","ref":"partisan_plumtree_broadcast.html#update/1","title":"partisan_plumtree_broadcast.update/1","type":"function"},{"doc":"","ref":"partisan_plumtree_broadcast.html#t:exchange/0","title":"partisan_plumtree_broadcast.exchange/0","type":"type"},{"doc":"","ref":"partisan_plumtree_broadcast.html#t:exchanges/0","title":"partisan_plumtree_broadcast.exchanges/0","type":"type"},{"doc":"","ref":"partisan_plumtree_broadcast.html#t:message_id/0","title":"partisan_plumtree_broadcast.message_id/0","type":"type"},{"doc":"Lazy messages that have not been acked. Messages are added to this set when a node is sent a lazy message (or when it should be sent one sometime in the future). Messages are removed when the lazy pushes are acknowledged via graft or ignores. Entries are keyed by their destination These are stored in the ?PLUMTREE_OUTSTANDING ets table under using nodename as key. PLUMTREE_OUTSTANDING is created and owned by partisan_sup","ref":"partisan_plumtree_broadcast.html#t:message_round/0","title":"partisan_plumtree_broadcast.message_round/0","type":"type"},{"doc":"","ref":"partisan_plumtree_broadcast.html#t:nodeset/0","title":"partisan_plumtree_broadcast.nodeset/0","type":"type"},{"doc":"","ref":"partisan_plumtree_broadcast.html#t:opts/0","title":"partisan_plumtree_broadcast.opts/0","type":"type"},{"doc":"","ref":"partisan_plumtree_broadcast.html#t:opts_list/0","title":"partisan_plumtree_broadcast.opts_list/0","type":"type"},{"doc":"","ref":"partisan_plumtree_broadcast.html#t:opts_map/0","title":"partisan_plumtree_broadcast.opts_map/0","type":"type"},{"doc":"","ref":"partisan_plumtree_broadcast.html#t:outstanding/0","title":"partisan_plumtree_broadcast.outstanding/0","type":"type"},{"doc":"","ref":"partisan_plumtree_broadcast.html#t:selector/0","title":"partisan_plumtree_broadcast.selector/0","type":"type"},{"doc":"","ref":"partisan_plumtree_broadcast.html#t:state/0","title":"partisan_plumtree_broadcast.state/0","type":"type"},{"doc":"This module defines a behaviour to customise the implementation for the operations performed by the partisan_plumtree_broadcast server. Callbacks The behaviour defines the following callbacks: broadcast_data/1 - must return a two-tuple of message id and payload from a given broadcast. Where the broadcasted message is application-specific. broadcast_channel/1 (optional) - Must return the channel to be used when broadcasting data associate with this handler. See partisan_plumtree_broadcast:broadcast/2 .","ref":"partisan_plumtree_broadcast_handler.html","title":"partisan_plumtree_broadcast_handler","type":"behaviour"},{"doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:broadcast_channel/0","title":"partisan_plumtree_broadcast_handler.broadcast_channel/0","type":"callback"},{"doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:broadcast_data/1","title":"partisan_plumtree_broadcast_handler.broadcast_data/1","type":"callback"},{"doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:exchange/1","title":"partisan_plumtree_broadcast_handler.exchange/1","type":"callback"},{"doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:graft/1","title":"partisan_plumtree_broadcast_handler.graft/1","type":"callback"},{"doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:is_stale/1","title":"partisan_plumtree_broadcast_handler.is_stale/1","type":"callback"},{"doc":"","ref":"partisan_plumtree_broadcast_handler.html#c:merge/2","title":"partisan_plumtree_broadcast_handler.merge/2","type":"callback"},{"doc":"","ref":"partisan_plumtree_util.html","title":"partisan_plumtree_util","type":"module"},{"doc":"Convert a list of elements into an N-ary tree. This conversion works by treating the list as an array-based tree where, for example in a binary 2-ary tree, a node at index i has children 2i and 2i+1. The conversion also supports a &quot;cycles&quot; mode where the array is logically wrapped around to ensure leaf nodes also have children by giving them backedges to other elements.","ref":"partisan_plumtree_util.html#build_tree/3","title":"partisan_plumtree_util.build_tree/3","type":"function"},{"doc":"","ref":"partisan_plumtree_util.html#log/2","title":"partisan_plumtree_util.log/2","type":"function"},{"doc":"","ref":"partisan_plumtree_util.html#log/3","title":"partisan_plumtree_util.log/3","type":"function"},{"doc":"","ref":"partisan_acknowledgement_backend.html","title":"partisan_acknowledgement_backend","type":"module"},{"doc":"","ref":"partisan_acknowledgement_backend.html#ack/1","title":"partisan_acknowledgement_backend.ack/1","type":"function"},{"doc":"","ref":"partisan_acknowledgement_backend.html#outstanding/0","title":"partisan_acknowledgement_backend.outstanding/0","type":"function"},{"doc":"","ref":"partisan_acknowledgement_backend.html#start_link/0","title":"partisan_acknowledgement_backend.start_link/0","type":"function"},{"doc":"","ref":"partisan_acknowledgement_backend.html#store/2","title":"partisan_acknowledgement_backend.store/2","type":"function"},{"doc":"","ref":"partisan_causality_backend.html","title":"partisan_causality_backend","type":"module"},{"doc":"","ref":"partisan_causality_backend.html#emit/4","title":"partisan_causality_backend.emit/4","type":"function"},{"doc":"","ref":"partisan_causality_backend.html#handle_call/3","title":"partisan_causality_backend.handle_call/3","type":"function"},{"doc":"Determine is a message is being sent with causal delivery or not.","ref":"partisan_causality_backend.html#is_causal_message/1","title":"partisan_causality_backend.is_causal_message/1","type":"function"},{"doc":"","ref":"partisan_causality_backend.html#receive_message/2","title":"partisan_causality_backend.receive_message/2","type":"function"},{"doc":"","ref":"partisan_causality_backend.html#reemit/2","title":"partisan_causality_backend.reemit/2","type":"function"},{"doc":"","ref":"partisan_causality_backend.html#set_delivery_fun/2","title":"partisan_causality_backend.set_delivery_fun/2","type":"function"},{"doc":"Same as start_link([]).","ref":"partisan_causality_backend.html#start_link/1","title":"partisan_causality_backend.start_link/1","type":"function"},{"doc":"","ref":"partisan_acceptor_pool.html","title":"partisan_acceptor_pool","type":"module"},{"doc":"","ref":"partisan_acceptor_pool.html#accept_socket/2","title":"partisan_acceptor_pool.accept_socket/2","type":"function"},{"doc":"","ref":"partisan_acceptor_pool.html#init/1","title":"partisan_acceptor_pool.init/1","type":"function"},{"doc":"","ref":"partisan_acceptor_pool.html#start_link/0","title":"partisan_acceptor_pool.start_link/0","type":"function"},{"doc":"","ref":"partisan_acceptor_socket.html","title":"partisan_acceptor_socket","type":"module"},{"doc":"","ref":"partisan_acceptor_socket.html#code_change/3","title":"partisan_acceptor_socket.code_change/3","type":"function"},{"doc":"","ref":"partisan_acceptor_socket.html#handle_call/3","title":"partisan_acceptor_socket.handle_call/3","type":"function"},{"doc":"","ref":"partisan_acceptor_socket.html#handle_cast/2","title":"partisan_acceptor_socket.handle_cast/2","type":"function"},{"doc":"","ref":"partisan_acceptor_socket.html#handle_info/2","title":"partisan_acceptor_socket.handle_info/2","type":"function"},{"doc":"","ref":"partisan_acceptor_socket.html#init/1","title":"partisan_acceptor_socket.init/1","type":"function"},{"doc":"","ref":"partisan_acceptor_socket.html#start_link/2","title":"partisan_acceptor_socket.start_link/2","type":"function"},{"doc":"","ref":"partisan_acceptor_socket.html#terminate/2","title":"partisan_acceptor_socket.terminate/2","type":"function"},{"doc":"","ref":"partisan_acceptor_socket_pool_sup.html","title":"partisan_acceptor_socket_pool_sup","type":"module"},{"doc":"","ref":"partisan_acceptor_socket_pool_sup.html#init/1","title":"partisan_acceptor_socket_pool_sup.init/1","type":"function"},{"doc":"","ref":"partisan_acceptor_socket_pool_sup.html#start_link/0","title":"partisan_acceptor_socket_pool_sup.start_link/0","type":"function"},{"doc":"","ref":"partisan_peer_connections.html","title":"partisan_peer_connections","type":"module"},{"doc":"Returns the channel name of the connection","ref":"partisan_peer_connections.html#channel/1","title":"partisan_peer_connections.channel/1","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#connection_count/0","title":"partisan_peer_connections.connection_count/0","type":"function"},{"doc":"Returns the number of connections for node Node . When passed a partisan:node_spec/0 as Arg it is equivalent to calling connection_count/2 with a wildcard as a second argument i.e. '_'. However, when passed a node()` as `Arg is uses the more efficient ets` `lookup_element operation.","ref":"partisan_peer_connections.html#connection_count/1","title":"partisan_peer_connections.connection_count/1","type":"function"},{"doc":"Returns the nbr of connections for node Node and channel Channel .","ref":"partisan_peer_connections.html#connection_count/2","title":"partisan_peer_connections.connection_count/2","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#connection_count/3","title":"partisan_peer_connections.connection_count/3","type":"function"},{"doc":"Finds connection for a node.","ref":"partisan_peer_connections.html#connections/0","title":"partisan_peer_connections.connections/0","type":"function"},{"doc":"Finds connection for a node.","ref":"partisan_peer_connections.html#connections/1","title":"partisan_peer_connections.connections/1","type":"function"},{"doc":"Finds connection for a node and channel.","ref":"partisan_peer_connections.html#connections/2","title":"partisan_peer_connections.connections/2","type":"function"},{"doc":"Finds connection for a node and channel.","ref":"partisan_peer_connections.html#connections/3","title":"partisan_peer_connections.connections/3","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#dispatch/1","title":"partisan_peer_connections.dispatch/1","type":"function"},{"doc":"Return a pid to use for message dispatch.","ref":"partisan_peer_connections.html#dispatch_pid/1","title":"partisan_peer_connections.dispatch_pid/1","type":"function"},{"doc":"Return a pid to use for message dispatch.","ref":"partisan_peer_connections.html#dispatch_pid/2","title":"partisan_peer_connections.dispatch_pid/2","type":"function"},{"doc":"Return a {ok, Pid} where Pid is the connection pid to use for message dispatch. If channel Channel is disconnected it falls back to a default channel connection if one exists. If no connections exist returns {error, disconnected} .","ref":"partisan_peer_connections.html#dispatch_pid/3","title":"partisan_peer_connections.dispatch_pid/3","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#erase/1","title":"partisan_peer_connections.erase/1","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#fold/2","title":"partisan_peer_connections.fold/2","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#foreach/1","title":"partisan_peer_connections.foreach/1","type":"function"},{"doc":"Returns a tuple {ok, Value} , where Value is an instance of info() associated with Node , or error if no info is associated with Node .","ref":"partisan_peer_connections.html#info/1","title":"partisan_peer_connections.info/1","type":"function"},{"doc":"Creates a new connections table. The owner of the table is the calling process and the table is protected so only the owner can write to it.","ref":"partisan_peer_connections.html#init/0","title":"partisan_peer_connections.init/0","type":"function"},{"doc":"Returns true is this node is connected to NodeOrName . If Node is this node, returns true .","ref":"partisan_peer_connections.html#is_connected/1","title":"partisan_peer_connections.is_connected/1","type":"function"},{"doc":"Returns true is this node is connected to NodeOrName . If Node is this node, returns true .","ref":"partisan_peer_connections.html#is_connected/2","title":"partisan_peer_connections.is_connected/2","type":"function"},{"doc":"Returns true is this node has all the requested connections ( parallelism configuration parameter) for all the configured channels with node NodeOrSpec .","ref":"partisan_peer_connections.html#is_fully_connected/1","title":"partisan_peer_connections.is_fully_connected/1","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#kill_all/0","title":"partisan_peer_connections.kill_all/0","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#listen_addr/1","title":"partisan_peer_connections.listen_addr/1","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#node/1","title":"partisan_peer_connections.node/1","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#node_spec/1","title":"partisan_peer_connections.node_spec/1","type":"function"},{"doc":"Returns a list of all nodes specifications connected to this node.","ref":"partisan_peer_connections.html#node_specs/0","title":"partisan_peer_connections.node_specs/0","type":"function"},{"doc":"Returns a list of all nodes connected to this node through normal connections (that is, hidden nodes are not listed).","ref":"partisan_peer_connections.html#nodes/0","title":"partisan_peer_connections.nodes/0","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#pid/1","title":"partisan_peer_connections.pid/1","type":"function"},{"doc":"Returns the pids for all the active connection for a node.","ref":"partisan_peer_connections.html#processes/1","title":"partisan_peer_connections.processes/1","type":"function"},{"doc":"Returns the pids for all the active connection for a node and channel.","ref":"partisan_peer_connections.html#processes/2","title":"partisan_peer_connections.processes/2","type":"function"},{"doc":"Prune all occurrences of a connection pid returns the node where the pruned pid was found","ref":"partisan_peer_connections.html#prune/1","title":"partisan_peer_connections.prune/1","type":"function"},{"doc":"Store a connection","ref":"partisan_peer_connections.html#store/4","title":"partisan_peer_connections.store/4","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#timestamp/1","title":"partisan_peer_connections.timestamp/1","type":"function"},{"doc":"","ref":"partisan_peer_connections.html#t:connection/0","title":"partisan_peer_connections.connection/0","type":"type"},{"doc":"","ref":"partisan_peer_connections.html#t:connections/0","title":"partisan_peer_connections.connections/0","type":"type"},{"doc":"","ref":"partisan_peer_connections.html#t:info/0","title":"partisan_peer_connections.info/0","type":"type"},{"doc":"","ref":"partisan_peer_connections.html#t:listen_addr_spec/0","title":"partisan_peer_connections.listen_addr_spec/0","type":"type"},{"doc":"","ref":"partisan_peer_connections.html#t:maybe_var/1","title":"partisan_peer_connections.maybe_var/1","type":"type"},{"doc":"","ref":"partisan_peer_connections.html#t:optional/1","title":"partisan_peer_connections.optional/1","type":"type"},{"doc":"","ref":"partisan_peer_connections.html#t:var/0","title":"partisan_peer_connections.var/0","type":"type"},{"doc":"Wrapper that allows transparent usage of plain TCP or TLS socket for peer connections. This module also implements the monotonic channel functionality.","ref":"partisan_peer_socket.html","title":"partisan_peer_socket","type":"module"},{"doc":"Wraps a TCP socket with the appropriate information for transceiving on and controlling the socket later. If TLS/SSL is enabled, this performs the socket upgrade/negotiation before returning the wrapped socket.","ref":"partisan_peer_socket.html#accept/1","title":"partisan_peer_socket.accept/1","type":"function"},{"doc":"See also: gen_tcp:close/1 , ssl:close/1 .","ref":"partisan_peer_socket.html#close/1","title":"partisan_peer_socket.close/1","type":"function"},{"doc":"See also: gen_tcp:connect/3 , ssl:connect/3 .","ref":"partisan_peer_socket.html#connect/3","title":"partisan_peer_socket.connect/3","type":"function"},{"doc":"","ref":"partisan_peer_socket.html#connect/4","title":"partisan_peer_socket.connect/4","type":"function"},{"doc":"","ref":"partisan_peer_socket.html#connect/5","title":"partisan_peer_socket.connect/5","type":"function"},{"doc":"See also: gen_tcp:recv/2 , ssl:recv/2 .","ref":"partisan_peer_socket.html#recv/2","title":"partisan_peer_socket.recv/2","type":"function"},{"doc":"See also: gen_tcp:recv/3 , ssl:recv/3 .","ref":"partisan_peer_socket.html#recv/3","title":"partisan_peer_socket.recv/3","type":"function"},{"doc":"See also: gen_tcp:send/2 , ssl:send/2 .","ref":"partisan_peer_socket.html#send/2","title":"partisan_peer_socket.send/2","type":"function"},{"doc":"See also: inet:setopts/2 , ssl:setopts/2 .","ref":"partisan_peer_socket.html#setopts/2","title":"partisan_peer_socket.setopts/2","type":"function"},{"doc":"Returns the wrapped socket from within the connection.","ref":"partisan_peer_socket.html#socket/1","title":"partisan_peer_socket.socket/1","type":"function"},{"doc":"","ref":"partisan_peer_socket.html#t:options/0","title":"partisan_peer_socket.options/0","type":"type"},{"doc":"","ref":"partisan_peer_socket.html#t:reason/0","title":"partisan_peer_socket.reason/0","type":"type"},{"doc":"","ref":"partisan_peer_socket.html#t:t/0","title":"partisan_peer_socket.t/0","type":"type"},{"doc":"","ref":"partisan_compose_orchestration_strategy.html","title":"partisan_compose_orchestration_strategy","type":"module"},{"doc":"","ref":"partisan_kubernetes_orchestration_strategy.html","title":"partisan_kubernetes_orchestration_strategy","type":"module"},{"doc":"","ref":"partisan_orchestration_backend.html","title":"partisan_orchestration_backend","type":"behaviour"},{"doc":"","ref":"partisan_orchestration_backend.html#c:clients/1","title":"partisan_orchestration_backend.clients/1","type":"callback"},{"doc":"","ref":"partisan_orchestration_backend.html#c:download_artifact/2","title":"partisan_orchestration_backend.download_artifact/2","type":"callback"},{"doc":"","ref":"partisan_orchestration_backend.html#graph/0","title":"partisan_orchestration_backend.graph/0","type":"function"},{"doc":"","ref":"partisan_orchestration_backend.html#nodes/0","title":"partisan_orchestration_backend.nodes/0","type":"function"},{"doc":"","ref":"partisan_orchestration_backend.html#orchestrated/0","title":"partisan_orchestration_backend.orchestrated/0","type":"function"},{"doc":"","ref":"partisan_orchestration_backend.html#orchestration/0","title":"partisan_orchestration_backend.orchestration/0","type":"function"},{"doc":"","ref":"partisan_orchestration_backend.html#servers/0","title":"partisan_orchestration_backend.servers/0","type":"function"},{"doc":"","ref":"partisan_orchestration_backend.html#c:servers/1","title":"partisan_orchestration_backend.servers/1","type":"callback"},{"doc":"Same as start_link([]).","ref":"partisan_orchestration_backend.html#start_link/0","title":"partisan_orchestration_backend.start_link/0","type":"function"},{"doc":"Start and link to calling process.","ref":"partisan_orchestration_backend.html#start_link/1","title":"partisan_orchestration_backend.start_link/1","type":"function"},{"doc":"","ref":"partisan_orchestration_backend.html#tree/0","title":"partisan_orchestration_backend.tree/0","type":"function"},{"doc":"","ref":"partisan_orchestration_backend.html#c:upload_artifact/3","title":"partisan_orchestration_backend.upload_artifact/3","type":"callback"},{"doc":"","ref":"partisan_orchestration_backend.html#was_connected/0","title":"partisan_orchestration_backend.was_connected/0","type":"function"},{"doc":"","ref":"partisan_orchestration_strategy.html","title":"partisan_orchestration_strategy","type":"behaviour"},{"doc":"","ref":"partisan_orchestration_strategy.html#c:clients/1","title":"partisan_orchestration_strategy.clients/1","type":"callback"},{"doc":"","ref":"partisan_orchestration_strategy.html#c:download_artifact/2","title":"partisan_orchestration_strategy.download_artifact/2","type":"callback"},{"doc":"","ref":"partisan_orchestration_strategy.html#c:servers/1","title":"partisan_orchestration_strategy.servers/1","type":"callback"},{"doc":"","ref":"partisan_orchestration_strategy.html#c:upload_artifact/3","title":"partisan_orchestration_strategy.upload_artifact/3","type":"callback"},{"doc":"","ref":"partisan_trace_file.html","title":"partisan_trace_file","type":"module"},{"doc":"","ref":"partisan_trace_file.html#read/1","title":"partisan_trace_file.read/1","type":"function"},{"doc":"","ref":"partisan_trace_file.html#write/2","title":"partisan_trace_file.write/2","type":"function"},{"doc":"","ref":"partisan_trace_orchestrator.html","title":"partisan_trace_orchestrator","type":"module"},{"doc":"","ref":"partisan_trace_orchestrator.html#debug/2","title":"partisan_trace_orchestrator.debug/2","type":"function"},{"doc":"Enable trace.","ref":"partisan_trace_orchestrator.html#enable/1","title":"partisan_trace_orchestrator.enable/1","type":"function"},{"doc":"Identify trace.","ref":"partisan_trace_orchestrator.html#identify/1","title":"partisan_trace_orchestrator.identify/1","type":"function"},{"doc":"","ref":"partisan_trace_orchestrator.html#is_membership_strategy_message/2","title":"partisan_trace_orchestrator.is_membership_strategy_message/2","type":"function"},{"doc":"Perform preloads.","ref":"partisan_trace_orchestrator.html#perform_preloads/1","title":"partisan_trace_orchestrator.perform_preloads/1","type":"function"},{"doc":"Print trace.","ref":"partisan_trace_orchestrator.html#print/0","title":"partisan_trace_orchestrator.print/0","type":"function"},{"doc":"Replay trace.","ref":"partisan_trace_orchestrator.html#replay/2","title":"partisan_trace_orchestrator.replay/2","type":"function"},{"doc":"","ref":"partisan_trace_orchestrator.html#replay_debug/2","title":"partisan_trace_orchestrator.replay_debug/2","type":"function"},{"doc":"Reset trace.","ref":"partisan_trace_orchestrator.html#reset/0","title":"partisan_trace_orchestrator.reset/0","type":"function"},{"doc":"Same as start_link([]).","ref":"partisan_trace_orchestrator.html#start_link/0","title":"partisan_trace_orchestrator.start_link/0","type":"function"},{"doc":"Start and link to calling process.","ref":"partisan_trace_orchestrator.html#start_link/1","title":"partisan_trace_orchestrator.start_link/1","type":"function"},{"doc":"","ref":"partisan_trace_orchestrator.html#stop/0","title":"partisan_trace_orchestrator.stop/0","type":"function"},{"doc":"Record trace message.","ref":"partisan_trace_orchestrator.html#trace/2","title":"partisan_trace_orchestrator.trace/2","type":"function"},{"doc":"","ref":"partisan_app.html","title":"partisan_app","type":"module"},{"doc":"Starts the application.","ref":"partisan_app.html#start/2","title":"partisan_app.start/2","type":"function"},{"doc":"Stop the application.","ref":"partisan_app.html#stop/1","title":"partisan_app.stop/1","type":"function"},{"doc":"","ref":"partisan_sup.html","title":"partisan_sup","type":"module"},{"doc":"","ref":"partisan_sup.html#init/1","title":"partisan_sup.init/1","type":"function"},{"doc":"","ref":"partisan_sup.html#start_link/0","title":"partisan_sup.start_link/0","type":"function"},{"doc":"","ref":"partisan_analysis.html","title":"partisan_analysis","type":"module"},{"doc":"","ref":"partisan_analysis.html#annotate/1","title":"partisan_analysis.annotate/1","type":"function"},{"doc":"","ref":"partisan_analysis.html#intraprocedural/1","title":"partisan_analysis.intraprocedural/1","type":"function"},{"doc":"","ref":"partisan_analysis.html#is_escape_op/2","title":"partisan_analysis.is_escape_op/2","type":"function"},{"doc":"","ref":"partisan_analysis.html#is_escape_op/3","title":"partisan_analysis.is_escape_op/3","type":"function"},{"doc":"","ref":"partisan_analysis.html#is_literal_op/2","title":"partisan_analysis.is_literal_op/2","type":"function"},{"doc":"","ref":"partisan_analysis.html#is_literal_op/3","title":"partisan_analysis.is_literal_op/3","type":"function"},{"doc":"","ref":"partisan_analysis.html#partisan_analysis/1","title":"partisan_analysis.partisan_analysis/1","type":"function"},{"doc":"","ref":"partisan_analysis.html#t:escapes/0","title":"partisan_analysis.escapes/0","type":"type"},{"doc":"","ref":"partisan_analysis.html#t:label/0","title":"partisan_analysis.label/0","type":"type"},{"doc":"","ref":"partisan_analysis.html#t:labelset/0","title":"partisan_analysis.labelset/0","type":"type"},{"doc":"XXX: TAKE ME OUT","ref":"partisan_analysis.html#t:ordset/1","title":"partisan_analysis.ordset/1","type":"type"},{"doc":"","ref":"partisan_analysis.html#t:outlist/0","title":"partisan_analysis.outlist/0","type":"type"},{"doc":"","ref":"partisan_inet.html","title":"partisan_inet","type":"module"},{"doc":"","ref":"partisan_inet.html#code_change/3","title":"partisan_inet.code_change/3","type":"function"},{"doc":"","ref":"partisan_inet.html#handle_call/3","title":"partisan_inet.handle_call/3","type":"function"},{"doc":"","ref":"partisan_inet.html#handle_cast/2","title":"partisan_inet.handle_cast/2","type":"function"},{"doc":"","ref":"partisan_inet.html#handle_info/2","title":"partisan_inet.handle_info/2","type":"function"},{"doc":"","ref":"partisan_inet.html#init/1","title":"partisan_inet.init/1","type":"function"},{"doc":"","ref":"partisan_inet.html#monitor/1","title":"partisan_inet.monitor/1","type":"function"},{"doc":"Returns connected if the host has at least one non-loopback network interface address. Otherwise returns disconnected .","ref":"partisan_inet.html#net_status/0","title":"partisan_inet.net_status/0","type":"function"},{"doc":"Returns connected if the host has at least one non-loopback network interface address. Otherwise returns disconnected .","ref":"partisan_inet.html#net_status/1","title":"partisan_inet.net_status/1","type":"function"},{"doc":"","ref":"partisan_inet.html#start_link/0","title":"partisan_inet.start_link/0","type":"function"},{"doc":"","ref":"partisan_inet.html#terminate/2","title":"partisan_inet.terminate/2","type":"function"},{"doc":"Parse transformation that replaces all instances of the Erlang bang operator ! with a call to partisan:forward_message/2 . Example: Pid ! hello will be transformed to partisan:forward_message(Pid, hello) .","ref":"partisan_transform.html","title":"partisan_transform","type":"module"},{"doc":"","ref":"partisan_transform.html#parse_transform/2","title":"partisan_transform.parse_transform/2","type":"function"},{"doc":"Ringleader parse transformation. First pass of a ringleader parse transformation to write send calls to use ringleader.","ref":"partisan_transformed_module.html","title":"partisan_transformed_module","type":"module"},{"doc":"","ref":"partisan_transformed_module.html#get_pid/0","title":"partisan_transformed_module.get_pid/0","type":"function"},{"doc":"","ref":"partisan_transformed_module.html#local_send/1","title":"partisan_transformed_module.local_send/1","type":"function"},{"doc":"","ref":"partisan_transformed_module.html#send_to_pid/2","title":"partisan_transformed_module.send_to_pid/2","type":"function"},{"doc":"","ref":"partisan_util.html","title":"partisan_util","type":"module"},{"doc":"","ref":"partisan_util.html#encode/1","title":"partisan_util.encode/1","type":"function"},{"doc":"If pid_encoding or ref_encoding configuration options are enabled, this function will ignore Opts and return an iolist(). Otherwise, the function calls erlang:term_to_iovec(Term, Opts) .'","ref":"partisan_util.html#encode/2","title":"partisan_util.encode/2","type":"function"},{"doc":"","ref":"partisan_util.html#encode_/1","title":"partisan_util.encode_/1","type":"function"},{"doc":"","ref":"partisan_util.html#get/2","title":"partisan_util.get/2","type":"function"},{"doc":"","ref":"partisan_util.html#get/3","title":"partisan_util.get/3","type":"function"},{"doc":"","ref":"partisan_util.html#maps_append/3","title":"partisan_util.maps_append/3","type":"function"},{"doc":"","ref":"partisan_util.html#maybe_connect_disterl/1","title":"partisan_util.maybe_connect_disterl/1","type":"function"},{"doc":"","ref":"partisan_util.html#maybe_pad_term/1","title":"partisan_util.maybe_pad_term/1","type":"function"},{"doc":"A simple Erlang implementation of vector clocks as inspired by Lamport logical clocks. Taken from Riak.","ref":"partisan_vclock.html","title":"partisan_vclock","type":"module"},{"doc":"Return the list of all nodes that have ever incremented VClock.","ref":"partisan_vclock.html#all_nodes/1","title":"partisan_vclock.all_nodes/1","type":"function"},{"doc":"Return true if Va is a direct descendant of Vb, else false -- remember, a vclock is its own descendant!","ref":"partisan_vclock.html#descends/2","title":"partisan_vclock.descends/2","type":"function"},{"doc":"","ref":"partisan_vclock.html#dominates/2","title":"partisan_vclock.dominates/2","type":"function"},{"doc":"Compares two VClocks for equality.","ref":"partisan_vclock.html#equal/2","title":"partisan_vclock.equal/2","type":"function"},{"doc":"Create a brand new vclock.","ref":"partisan_vclock.html#fresh/0","title":"partisan_vclock.fresh/0","type":"function"},{"doc":"takes the output of to_binary/1 and returns a vclock","ref":"partisan_vclock.html#from_binary/1","title":"partisan_vclock.from_binary/1","type":"function"},{"doc":"Get the counter value in VClock set from Node.","ref":"partisan_vclock.html#get_counter/2","title":"partisan_vclock.get_counter/2","type":"function"},{"doc":"take two vclocks and return a vclock that summerizes only the events both have seen.","ref":"partisan_vclock.html#glb/2","title":"partisan_vclock.glb/2","type":"function"},{"doc":"Increment VClock at Node.","ref":"partisan_vclock.html#increment/2","title":"partisan_vclock.increment/2","type":"function"},{"doc":"Combine all VClocks in the input list into their least possible common descendant.","ref":"partisan_vclock.html#merge/1","title":"partisan_vclock.merge/1","type":"function"},{"doc":"subtract the VClock from the DotList. what this means is that any {actor(), count()} pair in DotList that is &lt;= an entry in VClock is removed from DotList Example [{a, 3}, {b, 2}, {d, 14}, {g, 22}] - [{a, 4}, {b, 1}, {c, 1}, {d, 14}, {e, 5}, {f, 2}] = [{{b, 2}, {g, 22}]","ref":"partisan_vclock.html#subtract_dots/2","title":"partisan_vclock.subtract_dots/2","type":"function"},{"doc":"an efficient format for disk / wire. 5 @see from_binary/1","ref":"partisan_vclock.html#to_binary/1","title":"partisan_vclock.to_binary/1","type":"function"},{"doc":"The timestamp is present but not used, in case a client wishes to inspect it.","ref":"partisan_vclock.html#t:binary_vclock/0","title":"partisan_vclock.binary_vclock/0","type":"type"},{"doc":"","ref":"partisan_vclock.html#t:counter/0","title":"partisan_vclock.counter/0","type":"type"},{"doc":"","ref":"partisan_vclock.html#t:vc_entry/0","title":"partisan_vclock.vc_entry/0","type":"type"},{"doc":"","ref":"partisan_vclock.html#t:vclock/0","title":"partisan_vclock.vclock/0","type":"type"},{"doc":"","ref":"partisan_vclock.html#t:vclock_node/0","title":"partisan_vclock.vclock_node/0","type":"type"},{"doc":"TODO validate this module, align vs partisan_gen and if useful add gen_statem API, deprecating fsm API.","ref":"partisan_otp_adapter.html","title":"partisan_otp_adapter","type":"module"},{"doc":"","ref":"partisan_otp_adapter.html#call/6","title":"partisan_otp_adapter.call/6","type":"function"},{"doc":"","ref":"partisan_otp_adapter.html#gen_fsm_send_all_state_event/3","title":"partisan_otp_adapter.gen_fsm_send_all_state_event/3","type":"function"},{"doc":"Deprecated","ref":"partisan_otp_adapter.html#gen_fsm_send_event/3","title":"partisan_otp_adapter.gen_fsm_send_event/3","type":"function"},{"doc":"","ref":"partisan_otp_adapter.html#gen_fsm_sync_send_all_state_event/4","title":"partisan_otp_adapter.gen_fsm_sync_send_all_state_event/4","type":"function"},{"doc":"","ref":"partisan_otp_adapter.html#gen_fsm_sync_send_event/4","title":"partisan_otp_adapter.gen_fsm_sync_send_event/4","type":"function"},{"doc":"","ref":"partisan_otp_adapter.html#gen_server_call/4","title":"partisan_otp_adapter.gen_server_call/4","type":"function"},{"doc":"","ref":"partisan_otp_adapter.html#gen_server_cast/3","title":"partisan_otp_adapter.gen_server_cast/3","type":"function"},{"doc":"&lt;br&gt; Partisan is a scalable and flexible, TCP-based membership system and distribution layer for the BEAM. It bypasses the use of Distributed Erlang for manual connection management via TCP, and has several pluggable backends for different deployment scenarios. Partisan is a runtime system that enables greater scalability and reduced latency for distributed actor applications. Partisan improves scalability by allowing the application developer to specialize the overlay network to the application’s communication patterns. Partisan achieves lower latency by leveraging several predominately automatic optimizations that result in the efficient scheduling of messages. Bring Your Own Overlay - Partisan exposes an API for users to implement their own overlays; application developers must simply implement the membership_strategy interface for handling messages. Partisan automatically uses this membership strategy for processing incoming and outgoing messages to the system – the application developer only needs to handle internal state transitions and supplying the system with an updated list of members. Partisan automatically sets up required connections, serializes and deserializes messages, performs failure detection, and message forwarding. This makes it possible to implement protocols with very little code; our implementation of the full-mesh membership protocol is 152 LOC. Partisan is the first distributed actor system to expose this level of control to the application developer, improving the performance of existing actor application and enabling new types of actor applications.","ref":"readme.html","title":"Partisan","type":"extras"},{"doc":"See the documentation for Partisan at hex.pm . Alternatively you can build the documentation yourself locally using make docs . The resulting documentation will be found in the docs directory, just open the index.html file with your preferred web browser.","ref":"readme.html#getting-started","title":"Partisan - Getting started","type":"extras"},{"doc":"Erlang/OTP, specifically distributed erlang (a.k.a. disterl ), uses a full-mesh overlay network. This means that in the worst case scenario all nodes are connected-to and communicate-with all other nodes in the system. Failure detector . These nodes send periodic heartbeat messages to their connected nodes and deem a node &quot;failed&quot; or &quot;unreachable&quot; when it misses a certain number of heartbeat messages i.e. the net_tick_time setting in disterl . Due to this heartbeating and other issues in the way Erlang handles certain internal data structures, Erlang systems present a limit to the number of connected nodes that depending on the application goes between 60 and 200 nodes. Also, Erlang conflates control plane messages with application messages on the same TCP/IP connection and uses a single TCP/IP connection between two nodes, making it liable to the Head-of-line blocking issue. This also leads to congestion and contention that further affects latency. This model might scale well for datacenter deployments, where low latency can be assumed, but not for geo-distributed deployments, where latency is non-uniform and can show wide variance. Partisan was also designed to handle failures: Message omission Message reordering, this can happen in Erlang during reconnections State loss Bit flips Message corruption Faulty failure detectors Etc.","ref":"readme.html#why-do-we-need-partisan","title":"Partisan - Why do we need Partisan?","type":"extras"},{"doc":"Partisan was designed to increase scalability, reduce latency and improve failure detection for Erlang/BEAM distributed applications. Scalability Provides several overlays that are configurable at runtime partisan_pluggable_peer_service_manager : full mesh with TCP-based failure detection. All nodes maintain active connections to all other nodes in the system using one or more TPC connections. partisan_hyparview_peer_service_manager. : modified implementation of the HyParView protocol, peer-to-peer, designed for high scale, high churn environments. A hybrid partial view membership protocol, with TCP-based failure detection. partisan_client_server_peer_service_manager. : star topology, where clients communicate with servers, and servers communicate with other servers. partisan_static_peer_service_manager : static membership, where connections are explicitly made between nodes Specialised to particular application communication patterns Doesn't alter application behaviour Reduce latency Increasing parallelism - by configuring the number of TCP/IP connections between nodes (named channels). Pushing background and maintenance traffic to other communication channels - to avoid the Head-of-line blocking due to background activity Leveraging monotonicity - so that you can do load shedding more possible. Monotonic channels drop messages when state is increasing on the channel to reduce load and transmission of redundation information. Ideal for growing monotonic hash rings, objects designated with vector clock, CRDTs, etc. Failure detection Performed using TCP/IP Connections are verified at each gossip round Reliable delivery and stronger ordering Fault-injection Erlang-like API and OTP compliance Partisan offers re-implementations of gen_server and gen_statem . Monitoring: Partisan offers an API similar to the modules erlang and net_kernel for monitoring nodes and remote processes. Notice this currently only works for partisan_pluggable_peer_service_manager backend. Other On join, gossip is performed immediately, instead of having to wait for the next gossip round. Single node testing, facilitated by a disterl control channel for figuring out which ports the peer service is operating at.","ref":"readme.html#partisan-features","title":"Partisan - Partisan features","type":"extras"},{"doc":"Erlang/OTP 24+","ref":"readme.html#requirements","title":"Partisan - Requirements","type":"extras"},{"doc":"Projects Bondy Erleans PlumDB Organizations Leapsight","ref":"readme.html#who-is-using-partisan","title":"Partisan - Who is using Partisan","type":"extras"},{"doc":"Academic Papers Partisan: Enabling Real-World Protocol Evaluation - ApPLIED '18: Proceedings of the 2018 Workshop on Advanced Tools, Programming Languages, and PLatforms for Implementing and Evaluating Algorithms for Distributed systems, Christopher Meiklejohn Partisan: Enabling Cloud-Scale Erlang Applications , Christopher Meiklejohn, Heather Miller Partisan: Scaling the Distributed Actor Runtime - 2019 USENIX Annual Technical Conference, Christopher S. Meiklejohn and Heather Miller, Carnegie Mellon University; Peter Alvaro, UC Santa Cruz HyParView: a membership protocol for reliable gossip-based broadcast , Joao Leitao, Jose Pereira Luis Rodrigues. X-BOT: A Protocol for Resilient Optimization of Unstructured Overlay Networks , Joao Leitao, Jose Pereira Luis Rodrigues. Presentations Rethinking the Language Runtime for Scale - Erlang User Conference 2016, Christopher S. Meiklejohn Partisan: Scaling the Distributed Actor Runtime - 2019 USENIX Annual Technical Conference, Christopher S. Meiklejohn Partisan: testable, high performance, large scale distributed Erlang - Code BEAM SF 2019, Christopher S. Meiklejohn Distributed Erlang: From Datacenter Applications to Planetary Scale Applications , Christopher Meiklejohn.","ref":"readme.html#reference","title":"Partisan - Reference","type":"extras"},{"doc":"","ref":"cheatsheet.html","title":"Partisan Cheatsheet","type":"extras"},{"doc":"Partisan is configured using the normal sys.conf file and/or calling the functions in the partisan_config module. Example sys.config file [ { partisan , [ %% Which overlay to use { peer_service_manager , partisan_pluggable_peer_service_manager } , %% The listening port for Partisan TCP/IP connections { peer_port , 10200 } , %% The list of channels { channels , [ { data , \#{ parallelism =&gt; 1 } ] } , %% Encoding for pid(), reference() and names { pid_encoding , false } , { ref_encoding , false } , { remote_ref_format , improper_list } ] } , %% ...Other apps... ] . Notice that in order to work, all nodes in the cluster need to use the same configuration (apart from parameters like peer_port which can vary between nodes when deployed on the same host).","ref":"cheatsheet.html#configuring-partisan","title":"Partisan Cheatsheet - Configuring Partisan","type":"extras"},{"doc":"The following sections assumes you have two nodes running: ruby ( ruby@127.0.0.1 ) and max ( max@127.0.0.1 ). Manually joining using Erlang's console 1. Obtain max's node specification ( max @ 127.0 . 0.1 ) 1 &gt; NodeSpec = partisan : node_spec ( ) . 2. Join ruby with max ( ruby @ 127.0 . 0.1 ) 1 &gt; NodeSpec = . . . ( ruby @ 127.0 . 0.1 ) 2 &gt; partisan_peer_service : join ( NodeSpec ) . NodeSpec is the value obtained at max in the previous step. Checking cluster membership view Obtain members ( max @ 127.0 . 0.1 ) 1 &gt; partisan_peer_service : members ( ) . Returns [node_spec()] and should contain both node specifications. Obtain nodes ( max @ 127.0 . 0.1 ) 1 &gt; partisan : nodes ( ) . Returns [node()] and should contain both nodes. Obtain max's shell pid ( max @ 127.0 . 0.1 ) 2 &gt; partisan : self ( ) . [ &#39;max@127.0.0.1&#39; | &lt;&lt; &quot;#Pid&lt;0.813.0&gt;&quot; &gt;&gt; ] Returns partisan_remote_ref:t() . Notice this can be a tuple and improper list or a URI binary depending on the configuration option remote_ref_format which defaults to improper_list . Send message from ruby to max ( ruby @ 127.0 . 0.1 ) 3 &gt; Ref = [ &#39;max@127.0.0.1&#39; | &lt;&lt; &quot;#Pid&lt;0.813.0&gt;&quot; &gt;&gt; ] . ( ruby @ 127.0 . 0.1 ) 4 &gt; partisan : forward_message ( Ref , hello ) . Check the message arrived at max ( max @ 127.0 . 0.1 ) 3 &gt; flush ( ) . Shell got hello ok Leave the cluster ( max @ 127.0 . 0.1 ) 4 &gt; partisan_peer_service : leave ( ) . ok","ref":"cheatsheet.html#connecting-to-other-peers-and-sending-messages","title":"Partisan Cheatsheet - Connecting to other peers and sending messages","type":"extras"},{"doc":"In addition to using Partisan-specific functions to manage a cluster and send messages, adopting Partisan implies the need to replace some Erlang BIFs with Partisan's counterparts. This is mainly to cope with the impossibility for Partisan to represent remote pids and references in the way Distributed Erlang does. For that reason, pids and references are encoded manually (or automatically is the configuration options pid_encoding and ref_encoding are enabled) using the partisan_remote_ref:from_term/1 function. Several Erlang BIFs (a.k.a &quot;native implementation&quot;) won't work when using Partisan so you will need to use the Partisan API instead. The Partisan API tries to be a dropin replacement to Erlang's as much as possible. It tries comply with Erlang's in terms of naming, function signature and behaviour, so in most cases migrating to Partisan is as easy as replacing the module name from erlang to partisan . Erlang Partisan Description erlang:cancel_timer/1 partisan:cancel_timer/1 erlang:cancel_timer/2 partisan:cancel_timer/2 erlang:demonitor/1 partisan:demonitor/1 erlang:demonitor/2 partisan:demonitor/2 erlang:disconnect_node/1 partisan:disconnect_node/1 erlang:exit/2 partisan:exit/2 erlang:is_alive/0 partisan:is_alive/0 erlang:is_pid/1 partisan:is_pid/1 erlang:is_process_alive/1 partisan:is_process_alive/1 erlang:is_reference/1 partisan:is_reference/1 erlang:make_ref/0 partisan:make_ref/0 erlang:monitor/1 partisan:monitor/1 erlang:monitor/2 partisan:monitor/2 erlang:monitor/3 partisan:monitor/3 erlang:node/0 partisan:node/0 erlang:node/1 partisan:node/1 erlang:process_info/1 partisan:process_info/1 erlang:process_info/2 partisan:process_info/2 erlang:self/0 partisan:self/0 erlang:send/2 partisan:send/2 erlang:send/3 partisan:send/3 erlang:send_after/3 partisan:send_after/3 Accepts a partisan_remote_ref:t() as destination. When destination is a local pid, it reverts to the native implementation. erlang:send_after/4 partisan:send_after/4 Accepts a partisan_remote_ref:t() as destination. When destination is a local pid, it reverts to the native implementation. erlang:spawn/2 partisan:spawn/2 erlang:spawn/4 partisan:spawn/4 erlang:spawn_monitor/2 partisan:spawn_monitor/2 erlang:spawn_monitor/4 partisan:spawn_monitor/4 erlang:whereis/1 partisan:whereis/1 net_kernel:monitor_node/2 partisan:monitor_node/2 net_kernel:monitor_nodes/1 partisan:monitor_nodes/1 net_kernel:monitor_nodes/2 partisan:monitor_nodes/2","ref":"cheatsheet.html#migrating-from-distributed-erlang","title":"Partisan Cheatsheet - Migrating from Distributed Erlang","type":"extras"},{"doc":"Copyright (c) 2021-2022, Leapsight Technologies Limited Copyright (c) 2016, Christopher Meiklejohn Copyright (c) 2015, Basho Technologies, Inc Copyright (c) 2015, Helium Systems, Inc All rights reserved. Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"v5.0.0-beta.24 Removed eqwalizer from default profile v5.0.0-beta.23 Bug Fixes Coerce forward_options configuration option to map format. Fix bug in merge of forward options on partisan_pluggable_peer_service module Test suite fixes Export missing partisan:monitor_node/3 function. Fix a bug in partisan_hyparview_peer_service_message when Options are passed as list. Changes Remove unused module partisan_promise_backend v5.0.0-beta.22 Bug Fixes Continued adding support for OTP. The OTP modules sys , proc_lib where patched ( partisan_sys , partisan_proc_lib ) so that they support the partisan_remote_ref:t() type and use the partisan module functions for finding, monitoring and sending messages instead of the native Erlang counterparts. OTP patched files are located in the priv directory and loaded dynamically by rebar.config.script based on the Erlang/OTP version being used. Patched the CT suites ( gen_server_SUITE , gen_statem_SUITE , gen_event_SUITE ) to test the partisan OTP modules. All tests passing except for some test cases that require not-yet implemented features like global and some rpc functions. Notice global is not yet supported by Partisan. Added support for Eqwalizer, and passed both Eqwalizer and Dialyzer checks Additions New improper list format for partisan_remote_ref . This deprecates the config option remote_ref_as_uri and adds remote_ref_format instead which accepts improper_list (the new default), tuple (the legacy format) and uri (also introduced in v5). Adds partisan_erpc . The patched version of the Erlang's erpc module. v5.0.0-beta.19 Bug Fixes Fix implementation of partisan_pluggable_peer_service_manager:sync_join/1 . v5.0.0-beta.18 Bug Fixes Remove optimisation from partisan:self/0 and add partisan:self/1 which accepts the cache option making the use of th optimization to be explicit. Check the docs for the explanation. Fixed bug in partisan:monitor/2 introduced in previous version. v5.0.0-beta.17 Bug Fixes Fix bugs in partisan_gen_statem and partisan_gen v5.0.0-beta.16 Bug Fixes Fix a bug in partisan:send/2,3 Changes Ensure the membership channel ( partisan_membership ) exits and is properly configured. v5.0.0-beta.15 Bug Fixes General bug fixes including: #121 updated_members should only accept a list of maps (an never a list of nodes) fix wrong calls to self() and node() as opposed to their partisan counterparts Fixed bugs in partisan_monitor Several bug fixes in the OTP implementation Several bug fixes in the CT suite Changes Changed signature of partisan_membership_strategy and the implementing modules; added API e.g. join(state(), partisan:node_spec(), state()) is now join(partisan:node_spec(), state(), state()) which is more natural. Added partisan_membership_strategy API functions, so that pluggable manager can call these functions Some other naming changes to disambiguate e.g. membership -&gt; members moved some opt types from partisan_monitor to partisan module Fixed missing of gen_ and partisan_gen function calls. Made channel options to be respected across the stack Added channel configuration to partisan_monitor calls. Added channel to OTP behaviours. The messages and the monitor signals will be sent using the configured channel. overloaded gen_server/statem functions to accept options including channel so that we do not add another function to the API store the Partisan opts in the process dict (again to avoid modifying our changed versions of the behaviours) * Configuration parameters renaming. Several configuration parameters were renamed. Check partisan_config module description. The old parameters are still accepted but are renamed during startup. Deprecated the partisan_peer_service_manager:myself callback Fix partisan_util term encoding and renamed function; added compression option for encoding and for memberhip payload Additions Added the following modules: partisan_supervisor behaviour Added the following functions: partisan:exit/2 partisan:send/2 partisan:send/3 partisan:send_after/3 partisan:send_after/4 partisan:cancel_timer/1 partisan:cancel_timer/2 Peer Service manager now allows subscribing to events per channel partisan_peer_service_manager:on_up/3 accepting a channel partisan_peer_service_manager:on_down/3 accepting a channel v5.0.0-beta.14","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Changes Several functions previously found in partisan_util are now in partisan_peer_service_manager . Types previously found in partisan.hrl are now defined and exported by the partisan module.","ref":"changelog.html#api","title":"CHANGELOG - API","type":"extras"},{"doc":"Fixes Several bug fixes in the following backends: partisan_hyparview_peer_service_manager partisan_xbot_hyparview_peer_service_manager partisan_client_server_peer_service_manager Fixes a bug in partisan_plumbtree_broadcast where not all the handlers were used. The configuration option broadcast_start_exchange_limit is now considered to refer to each handler i.e. a limit of 1 means Partisan will only allow one instance of a broadcast AAE exchange per handler (and not a single one in total).","ref":"changelog.html#peer-membership","title":"CHANGELOG - Peer Membership","type":"extras"},{"doc":"Changes Channel parallelism can now be defined per channel channels configuration option is overloaded to allow the new configuration options while keeping backwards compatibility. Check the documentation for the new formats in partisan_config . The partisan:node_spec/0 representation was changed: parallelism was removed channels was changed from a list of atoms or tuples to a the return of partisan_config:get(channels) i.e. a map. parallelism is now used as a default when the user doesn’t define a per channel parallelism. The partisan module now exports the new function channel_opts/1 with returns the options for a given channel. v5.0.0-beta.13","ref":"changelog.html#peer-connection-management","title":"CHANGELOG - Peer Connection Management","type":"extras"},{"doc":"In general, the API was redesigned to concentrate all functions around two modules: partisan and partisan_peer_service . Changes partisan module was repurposed as a replacement for the erlang module for use cases related to distribution e.g. erlang:nodes/0 -&gt; partisan:nodes/0 . Several functions previously found in partisan_peer_service , partisan_monitor and partisan_util are now in this module: partisan:broadcast/2 partisan:cast_message/2 partisan:cast_message/3 partisan:cast_message/4 partisan:default_channel/0 partisan:demonitor/1 partisan:demonitor/2 partisan:disconnect_node/1 . partisan:forward_message/2 partisan:forward_message/3 partisan:forward_message/4 partisan:is_alive/0 partisan:is_connected/1 partisan:is_connected/2 partisan:is_fully_connected/1 partisan:is_local/1 partisan:is_pid/1 partisan:is_process_alive/1 partisan:is_reference/1 partisan:make_ref/0 partisan:monitor/1 partisan:monitor/2 partisan:monitor/3 partisan:monitor_node/2 partisan:monitor_nodes/1 partisan:monitor_nodes/2 partisan:node/0 partisan:node/1 partisan:node_spec/0 partisan:node_spec/1 partisan:node_spec/2 partisan:nodes/0 partisan:nodes/1 partisan:nodestring/0 partisan:self/0 Added the following functions: partisan_peer_service:broadcast_members/0 partisan_peer_service:broadcast_members/1 partisan_peer_service:cancel_exchanges/1 partisan_peer_service:exchanges/0 partisan_peer_service:exchanges/1 partisan_peer_service:get_local_state/0 partisan_peer_service:inject_partition/2 partisan_peer_service:leave/1 partisan_peer_service:member/1 partisan_peer_service:members_for_orchestration/0 partisan_peer_service:on_down/2 partisan_peer_service:on_up/2 partisan_peer_service:partitions/0 partisan_peer_service:reserve/1 partisan_peer_service:resolve_partition/1 partisan_peer_service:update_members/1 Use of partisan_peer_service:mynode/0 has been replaced by partisan:node/0 to follow Erlang convention Use of partisan_peer_service:myself/0 has been replaced by partisan:node_spec/0 to disambiguate from partisan:node/0 . Use of Node variable name for node() type (as opposed to Name ) and NodeSpec for node_spec() (as opposed to Node ) to disambiguate. Adde new module partisan_rpc that will provide and API that mirrors Erlangs rpc and erpc modules Added partisan_remote_ref to encapsulate the creation of reference and added an optional/alternative representation for encoded pids, references and registered names. The module offers all the functions to convert pids, references and names to/from Partisan encoded references. Alternative representation: In cases where lots of references are stored in process state, ets and specially where those are uses as keys, a binary format is preferable to the tuple format in order to save memory usage and avoid copying the term every time a message is send between processes. partisan_remote_ref represents an encoded reference as binary URI. This is controlled by the config option remote_ref_as_uri and remote_ref_binary_padding in case the resulting URIs are smaller than 65 bytes. 1 &gt; partisan_remote_ref : from_term ( self ( ) ) . { partisan_remote_reference , nonode @ nohost , { partisan_process_reference , &quot;&lt;0.1062.0&gt;&quot; } } 2 &gt; partisan_config : set ( remote_ref_as_uri , true ) . ok 3 &gt; partisan_remote_ref : from_term ( self ( ) ) . &lt;&lt; &quot;partisan:pid:nonode@nohost:0.1062.0&quot; &gt;&gt; 4 &gt; partisan_config : set ( remote_ref_binary_padding , true ) . ok 5 &gt; partisan_remote_ref : from_term ( self ( ) ) . &lt;&lt; &quot;partisan:pid:nonode@nohost:0.1062.0:&quot; . . . &gt;&gt;","ref":"changelog.html#api","title":"CHANGELOG - API","type":"extras"},{"doc":"Fixes Extracted the use of state_orset from partisan_full_membership_strategy into its own module partisan_membership_set which will allow the possibility to explore alternative data structures to manage the membership set. Introduced a membership prune operation to remove duplicate node specifications in the underlying state_orset data structure. This isto avoid an issue where a node will crash and restart with a different IP address e.g. when deploying in cloud orchestration platforms. As the membership set contains node_spec() objects which contain IP addresses we ended up with duplicate entries for the node. The prune operation tries to break ties between these duplicates at time of connection, trying to recognise when a node specification might be no longer valid forcing the removal of the spec from the set. Fixes several bugs related to the leave operation in partisan_pluggable_peer_service_manager : Added a missing call to update the membership set during leave Fixed a concurrency issue whereby on self leave the peer service server will restart before being able to sending the new state with the cluster peers and thus the node would remain as a member in all other nodes. Resolves an issue partisan_plumtree_broadcast where the all_members set was not updated when a member is removed. Resolves the issue where the partisan_plumtree_broadcast was not removing the local node from the broadcast member set. Gen Behaviours take new option channel if defined. Fixed implementation of on_up and on_down callback functions in partisan_pluggable_peer_service_manager Changes Added function partisan_peer_service_manager:member/1 Replaced the use of in-process sets in plumtree_broadcast_backend with an ets table for outstanding messages keeping the gen_server stack lean and avoiding garbage collection","ref":"changelog.html#peer-membership","title":"CHANGELOG - Peer Membership","type":"extras"},{"doc":"Fixes Fixes a bug where connections where not properly killed during a leave Split TLS options for client and server roles Removed tls_options Added tls_client_options and tls_server_options Changes New module peer_service_connections : Replaces the former peer_service_connections process state data structure and the partisan_connection_cache module. As a result, the partisan_connection_cache module has been was removed. Checking connection status is now very fast and cheap. The implementation uses ets to handle concurreny. It leverages leverages ets:update_counter/4 , ets:lookup_element/3 and ets:select_count/2 for fast access and to minimise copying data into the caller's process heap.","ref":"changelog.html#peer-connection-management","title":"CHANGELOG - Peer Connection management","type":"extras"},{"doc":"Fixes A more complete/safe implementation of process monitoring in partisan_monitor . More robust implementation of monitors using the new subscription capabilities provided by peer_service:on_up and peer_service:on_down callback functions. monitor a node or all nodes use node monitors to signal a process monitor when the remote node is disconnected local cache of process monitor to ensure the delivery of DOWN signal when the connection to the process node is down. avoid leaking monitors new supervisor to ensure that partisan_monitor is restarted every time the configured partisan_peer_service_manager is restarted. re-implementation based on ets tables If using OTP25 the monitor gen_server uses the parallel signal optimisation by placing the process inbox data off heap NOTICE At the moment this only works for partisan_pluggable_peer_service_manager backend. Changes New api in partisan module following the same name, signature and semantics of their erlang and net_kernel modules counterparts: partisan:monitor/1 partisan:monitor/2 partisan:monitor/3 partisan:monitor_node/2 partisan:monitor_nodes/1 partisan:monitor_nodes/2","ref":"changelog.html#process-and-peer-monitoring","title":"CHANGELOG - Process and Peer Monitoring","type":"extras"},{"doc":"Fixes Changes Partisan now requires OTP24 or later . Upgraded partisan_gen and partisan_gen_server to match their OTP24 counterparts implementation Added partisan_gen_statem partisan_gen_fsm deprecated as it was not complete and focus was given to the implementation of partisan_gen_statem instead Module partisan_mochiglobal has been removed and replaced by persistent_term","ref":"changelog.html#otp-compatibility","title":"CHANGELOG - OTP compatibility","type":"extras"},{"doc":"Fixes Most existing INFO level logs have been reclassified as DEBUG Fixed types specifications in various modules Changes lager dependency has been removed and all logging is done using the new Erlang logger Most uses of the orddict module have been replaced by maps for extra performance and better usability Most API options using proplists module have been replaced by maps for extra performance and better usability In several functions the computation of options (merging user provided with defaults, validation, etc.) has been postponed until (and only if) it is needed for extra performance e.g. partisan_pluggable_peer_servie_manager:forward_message More utils in partisan_util Added ex_doc (Elixir documentation) rebar plugin Upgraded the following dependencies: uuid types rebar plugins","ref":"changelog.html#misc","title":"CHANGELOG - Misc","type":"extras"},{"doc":"","ref":"code_of_conduct.html","title":"Contributor Covenant Code of Conduct","type":"extras"},{"doc":"In the interest of fostering an open and welcoming environment, we as contributors and maintainers pledge to making participation in our project and our community a harassment-free experience for everyone, regardless of age, body size, disability, ethnicity, gender identity and expression, level of experience, nationality, personal appearance, race, religion, or sexual identity and orientation.","ref":"code_of_conduct.html#our-pledge","title":"Contributor Covenant Code of Conduct - Our Pledge","type":"extras"},{"doc":"Examples of behavior that contributes to creating a positive environment include: Using welcoming and inclusive language Being respectful of differing viewpoints and experiences Gracefully accepting constructive criticism Focusing on what is best for the community Showing empathy towards other community members Examples of unacceptable behavior by participants include: The use of sexualized language or imagery and unwelcome sexual attention or advances Trolling, insulting/derogatory comments, and personal or political attacks Public or private harassment Publishing others' private information, such as a physical or electronic address, without explicit permission Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards","title":"Contributor Covenant Code of Conduct - Our Standards","type":"extras"},{"doc":"Project maintainers are responsible for clarifying the standards of acceptable behavior and are expected to take appropriate and fair corrective action in response to any instances of unacceptable behavior. Project maintainers have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, or to ban temporarily or permanently any contributor for other behaviors that they deem inappropriate, threatening, offensive, or harmful.","ref":"code_of_conduct.html#our-responsibilities","title":"Contributor Covenant Code of Conduct - Our Responsibilities","type":"extras"},{"doc":"This Code of Conduct applies both within project spaces and in public spaces when an individual is representing the project or its community. Examples of representing a project or community include using an official project e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event. Representation of a project may be further defined and clarified by project maintainers.","ref":"code_of_conduct.html#scope","title":"Contributor Covenant Code of Conduct - Scope","type":"extras"},{"doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported by contacting the project team at christopher.meiklejohn@gmail.com. The project team will review and investigate all complaints, and will respond in a way that it deems appropriate to the circumstances. The project team is obligated to maintain confidentiality with regard to the reporter of an incident. Further details of specific enforcement policies may be posted separately. Project maintainers who do not follow or enforce the Code of Conduct in good faith may face temporary or permanent repercussions as determined by other members of the project's leadership.","ref":"code_of_conduct.html#enforcement","title":"Contributor Covenant Code of Conduct - Enforcement","type":"extras"},{"doc":"This Code of Conduct is adapted from the Contributor Covenant , version 1.4, available at http://contributor-covenant.org/version/1/4","ref":"code_of_conduct.html#attribution","title":"Contributor Covenant Code of Conduct - Attribution","type":"extras"}]